Require Import malloc.
Require Import free.
Require Import cdsa.
Require Import lib_lemma.
Require Import copydefs.
Require Import copyblks.
Require Import scap_rules.
Require Import scap.
Require Import heap2.

Notation psi_global := (
  consCT L_free_prolog T_free_prolog (
  consCT L_free_entry T_free_entry (
  consCT L_free_iter T_free_iter (
  consCT L_free_next T_free_next (
  consCT L_free_trylo T_free_trylo (
  consCT L_free_tryhi T_free_tryhi (
  consCT L_free_notjhi T_free_notjhi (
  consCT L_free_lnklo T_free_lnklo (
  consCT L_free_epilog T_free_epilog (
  consCT L_free_notjlo T_free_notjlo(
  consCT L_malloc_prolog T_malloc_prolog (
  consCT L_malloc_init T_malloc_init (
  consCT L_malloc_epilog T_malloc_epilog (
  consCT L_malloc_iter T_malloc_iter (
  consCT L_malloc_comp T_malloc_comp (
  consCT L_malloc_split T_malloc_split (
  consCT L_malloc_next T_malloc_next (
  consCT L_malloc_lprv T_malloc_lprv (
  consCT L_malloc_retptr T_malloc_retptr (
  consCT L_copy_entry T_copy_entry (
  consCT L_copy_test T_copy_test (
  consCT L_copy_new T_copy_new (
  consCT L_copy_del T_copy_del (
  consCT L_copy_halt T_copy_halt (
  consCT L_copy_ahead T_copy_ahead (
  consCT L_copy_reorder_t T_copy_reorder_t (
  consCT L_copy_lnkprv T_copy_lnkprv emptyCT))))))))))))))))))))))))))).
  
Notation ch_global := (
  consCH L_free_prolog C_free_prolog (
  consCH L_free_entry C_free_entry (
  consCH L_free_iter C_free_iter (
  consCH L_free_next C_free_next (
  consCH L_free_trylo C_free_trylo (
  consCH L_free_tryhi C_free_tryhi (
  consCH L_free_notjhi C_free_notjhi (
  consCH L_free_lnklo C_free_lnklo (
  consCH L_free_epilog C_free_epilog (
  consCH L_free_notjlo C_free_notjlo(
  consCH L_malloc_prolog C_malloc_prolog (
  consCH L_malloc_init C_malloc_init (
  consCH L_malloc_epilog C_malloc_epilog (
  consCH L_malloc_iter C_malloc_iter (
  consCH L_malloc_comp C_malloc_comp (
  consCH L_malloc_split C_malloc_split (
  consCH L_malloc_next C_malloc_next (
  consCH L_malloc_lprv C_malloc_lprv (
  consCH L_malloc_retptr C_malloc_retptr (
  consCH L_copy_entry C_copy_entry (
  consCH L_copy_test C_copy_test (
  consCH L_copy_new C_copy_new (
  consCH L_copy_del C_copy_del (
  consCH L_copy_halt C_copy_halt (
  consCH L_copy_ahead C_copy_ahead (
  consCH L_copy_reorder_t C_copy_reorder_t (
  consCH L_copy_lnkprv C_copy_lnkprv emptyCH))))))))))))))))))))))))))).

Ltac unfoldlookupCT :=
  repeat match goal with 
          | |- lookupCT _ _ _ => constructor; [idtac | omega]
        end.

Theorem sub_psi_free_prolog : psi_subseteq psi_free_prolog psi_global.
Proof.
unfold psi_free_prolog.
constructor. intros. inversion H. constructor. inversion H5.
constructor; [constructor |omega]. inversion H12.
Save.

Lemma sub_psi_free_entry : psi_subseteq psi_free_entry psi_global.
Proof.
unfold psi_free_entry.
constructor; intros; inversion H.
unfoldlookupCT.
constructor.
inversion H5.
Save.

Lemma sub_psi_free_iter : psi_subseteq psi_free_iter psi_global.
Proof.
unfold psi_free_iter.
constructor; intros; inversion H.
unfoldlookupCT.
constructor.
inversion H5.
unfoldlookupCT.
constructor.
inversion H12.
Save.


Lemma sub_psi_free_next : psi_subseteq psi_free_next psi_global.
Proof.
unfold psi_free_next.
constructor; intros; inversion H.
unfoldlookupCT.
constructor.
inversion H5.
unfoldlookupCT.
constructor.
inversion H12.
Save.

Lemma sub_psi_free_trylo : psi_subseteq psi_free_trylo psi_global.
Proof.
unfold psi_free_trylo.
constructor; intros; inversion H.
unfoldlookupCT.
constructor.
inversion H5.
unfoldlookupCT.
constructor.
inversion H12.
Save.

Lemma sub_psi_free_tryhi : psi_subseteq psi_free_tryhi psi_global.
Proof.
unfold psi_free_tryhi.
constructor; intros; inversion H.
unfoldlookupCT.
constructor.
inversion H5.
unfoldlookupCT.
constructor.
inversion H12.
Save.

Lemma sub_psi_free_notjhi : psi_subseteq psi_free_notjhi psi_global.
Proof.
unfold psi_free_notjhi.
constructor; intros; inversion H.
unfoldlookupCT.
constructor.
inversion H5.
Save.

Lemma sub_psi_free_lnklo : psi_subseteq psi_free_lnklo psi_global.
Proof.
unfold psi_free_lnklo.
constructor; intros; inversion H.
unfoldlookupCT.
constructor.
inversion H5.
unfoldlookupCT.
constructor.
inversion H12.
Save.

Lemma sub_psi_free_epilog : psi_subseteq emptyCT psi_global.
Proof.
constructor; intros; inversion H.
Save.

Lemma sub_psi_free_notjlo : psi_subseteq psi_free_notjlo psi_global.
Proof.
unfold psi_free_notjlo.
constructor; intros; inversion H.
unfoldlookupCT.
constructor.
inversion H5.
Save.

Lemma sub_psi_malloc_prolog : psi_subseteq psi_malloc_prolog psi_global.
Proof.
constructor; intros; inversion H.
unfoldlookupCT.
constructor.
inversion H5.
Save.

Lemma sub_psi_malloc_init : psi_subseteq psi_malloc_init psi_global.
Proof.
constructor; intros; inversion H.
unfoldlookupCT.
constructor.
inversion H5.
Save.

Lemma sub_psi_malloc_epilog : psi_subseteq emptyCT psi_global.
Proof.
constructor; intros; inversion H.
Save.

Lemma sub_psi_malloc_iter : psi_subseteq psi_malloc_iter psi_global.
Proof.
constructor; intros; inversion H.
unfoldlookupCT.
constructor.
inversion H5.
unfoldlookupCT.
constructor.
inversion H12.
Save.

Lemma sub_psi_malloc_comp : psi_subseteq psi_malloc_comp psi_global.
Proof.
constructor; intros; inversion H.
unfoldlookupCT.
constructor.
inversion H5.
unfoldlookupCT.
constructor.
inversion H12.
unfoldlookupCT.
constructor.
inversion H19.
unfoldlookupCT.
constructor.
inversion H26.
Save.

Lemma sub_psi_malloc_split : psi_subseteq psi_malloc_split psi_global.
Proof.
constructor; intros; inversion H.
unfoldlookupCT.
constructor.
inversion H5.
Save.

Lemma sub_psi_malloc_next : psi_subseteq psi_malloc_next psi_global.
Proof.
constructor; intros; inversion H.
unfoldlookupCT.
constructor.
inversion H5.
Save.

Lemma sub_psi_malloc_lprv : psi_subseteq psi_malloc_lprv psi_global.
Proof.
constructor; intros; inversion H.
unfoldlookupCT.
constructor.
inversion H5.
Save.

Lemma sub_psi_malloc_retptr : psi_subseteq psi_malloc_retptr psi_global.
Proof.
constructor; intros; inversion H.
unfoldlookupCT.
constructor.
inversion H5.
Save.

Lemma sub_psi_copy_entry : psi_subseteq psi_copy_entry psi_global.
Proof.
constructor; intros; inversion H.
unfoldlookupCT.
constructor.
inversion H5.
Save.

Lemma sub_psi_copy_test : psi_subseteq psi_copy_test psi_global.
Proof.
constructor; intros; inversion H.
unfoldlookupCT.
constructor.
inversion H5.
unfoldlookupCT.
constructor.
inversion H12.
Save.

Lemma sub_psi_copy_new : psi_subseteq psi_copy_new psi_global.
Proof.
constructor; intros; inversion H.
unfoldlookupCT.
constructor.
inversion H5.
unfoldlookupCT.
constructor.
inversion H12.
Save.

Lemma sub_psi_copy_del : psi_subseteq psi_copy_del psi_global.
Proof.
constructor; intros; inversion H.
unfoldlookupCT.
constructor.
inversion H5.
unfoldlookupCT.
constructor.
inversion H12.
Save.

Lemma sub_psi_copy_halt : psi_subseteq psi_copy_halt psi_global.
Proof.
constructor; intros; inversion H.
unfoldlookupCT.
constructor.
inversion H5.
Save.

Lemma sub_psi_copy_ahead : psi_subseteq psi_copy_ahead psi_global.
Proof.
constructor; intros; inversion H.
unfoldlookupCT.
constructor.
inversion H5.
unfoldlookupCT.
constructor.
inversion H12.
Save.

Lemma sub_psi_copy_reorder_t : psi_subseteq psi_copy_reorder_t psi_global.
Proof.
constructor; intros; inversion H.
constructor.
inversion H5.
unfoldlookupCT.
constructor.
inversion H12.
Save.

Lemma sub_psi_copy_lnkprv : psi_subseteq psi_copy_lnkprv psi_global.
Proof.
constructor; intros; inversion H.
unfoldlookupCT.
constructor.
inversion H5.
Save.

Theorem WF_ch_global : WF_CH psi_global ch_global.
Proof.
constructor. constructor.
apply Infer_psi_strengthen with psi_free_prolog; [idtac|apply WF_free_prolog].
apply sub_psi_free_prolog.
constructor. 
apply Infer_psi_strengthen with psi_free_entry; [idtac|apply WF_free_entry].
apply sub_psi_free_entry.
constructor. 
apply Infer_psi_strengthen with psi_free_iter; [idtac|apply WF_free_iter].
apply sub_psi_free_iter.
constructor. 
apply Infer_psi_strengthen with psi_free_next; [idtac|apply WF_free_next].
apply sub_psi_free_next.
constructor. 
apply Infer_psi_strengthen with psi_free_trylo; [idtac|apply WF_free_trylo].
apply sub_psi_free_trylo.
constructor. 
apply Infer_psi_strengthen with psi_free_tryhi; [idtac|apply WF_free_tryhi].
apply sub_psi_free_tryhi.
constructor. 
apply Infer_psi_strengthen with psi_free_notjhi; [idtac|apply WF_free_notjhi].
apply sub_psi_free_notjhi.
constructor. 
apply Infer_psi_strengthen with psi_free_lnklo; [idtac|apply WF_free_lnklo].
apply sub_psi_free_lnklo.
constructor. 
apply Infer_psi_strengthen with emptyCT; [idtac|apply WF_free_epilog].
apply sub_psi_free_epilog.
constructor.
apply Infer_psi_strengthen with psi_free_notjlo; [idtac | apply WF_free_notjlo].
apply sub_psi_free_notjlo.
constructor. 
apply Infer_psi_strengthen with psi_malloc_prolog; 
  [idtac|apply WF_malloc_prolog].
apply sub_psi_malloc_prolog.
constructor. 
apply Infer_psi_strengthen with psi_malloc_init; 
  [idtac|apply WF_malloc_init].
apply sub_psi_malloc_init.
constructor. 
apply Infer_psi_strengthen with emptyCT; 
  [apply sub_psi_malloc_epilog|apply WF_malloc_epilog].
constructor. 
apply Infer_psi_strengthen with psi_malloc_iter; 
  [apply sub_psi_malloc_iter|apply WF_malloc_iter].
constructor. 
apply Infer_psi_strengthen with psi_malloc_comp; 
  [apply sub_psi_malloc_comp|apply WF_malloc_comp].
constructor. 
apply Infer_psi_strengthen with psi_malloc_split; 
  [apply sub_psi_malloc_split|apply WF_malloc_split].
constructor. 
apply Infer_psi_strengthen with psi_malloc_next; 
  [apply sub_psi_malloc_next|apply WF_malloc_next].
constructor. 
apply Infer_psi_strengthen with psi_malloc_lprv; 
  [apply sub_psi_malloc_lprv|apply WF_malloc_lprv].
constructor. 
apply Infer_psi_strengthen with psi_malloc_retptr; 
  [apply sub_psi_malloc_retptr|apply WF_malloc_retptr].
constructor. 
apply Infer_psi_strengthen with psi_copy_entry; 
  [apply sub_psi_copy_entry|apply WF_copy_entry].
constructor. 
apply Infer_psi_strengthen with psi_copy_test; 
  [apply sub_psi_copy_test|apply WF_copy_test].
constructor. 
apply Infer_psi_strengthen with psi_copy_new; 
  [apply sub_psi_copy_new|apply WF_copy_new].
constructor. 
apply Infer_psi_strengthen with psi_copy_del; 
  [apply sub_psi_copy_del|apply WF_copy_del].
constructor. 
apply Infer_psi_strengthen with psi_copy_halt; 
  [apply sub_psi_copy_halt|apply WF_copy_halt].
constructor. 
apply Infer_psi_strengthen with psi_copy_ahead; 
  [apply sub_psi_copy_ahead|apply WF_copy_ahead].
constructor. 
apply Infer_psi_strengthen with psi_copy_reorder_t; 
  [apply sub_psi_copy_reorder_t|apply WF_copy_reorder_t].
constructor. 
apply Infer_psi_strengthen with psi_copy_lnkprv; 
  [apply sub_psi_copy_lnkprv|apply WF_copy_lnkprv].
constructor. 
Save.

Theorem wf_world : forall (h : heap) (rf : rfile),
  P_copy_entry (h, rf) ->
  WF_WLD psi_global (itpx2 (itpx1 T_copy_entry) psi_copy_entry)
  ((h, rf), (ch_global, C_copy_entry)).
Proof.
constructor.
unfold itpx1. 
unfold itpx2.
split.
apply sub_psi_copy_entry.
split. auto.
exists 0.
constructor.
unfold G_copy_entry. 
intros.
unfold getValinR in H0. trivial.
apply WF_copy_entry.
apply WF_ch_global.
Save.










