Require Import scap_rules.
Require Import scap.
Require Import cdsa.
Require Import heap2.
Require Import lib_lemma.
Require Import Omega.
Require Import properties.
Require Import properties2.

Axiom zero_r : forall s : state, getValinR s zero = O.

Ltac free_unall H1 := try (unfold POPS0S1S2 in H1; unfold ET0T1T2; unfold ET0T1T2 in H1; 
  unfold RESRqd;unfold RESRqd in H1; unfold POPS0S1S2; unfold ES0S1S2 in H1; unfold ES0S1S2; 
    unGand H1; unRIntact H1).

Definition psi_free_prolog :=
  consCT L_free_prolog T_free_prolog (
  consCT L_free_entry T_free_entry emptyCT).

Definition psi_free_entry := consCT L_free_iter T_free_iter emptyCT.

Definition psi_free_iter := 
  consCT L_free_next T_free_next (
  consCT L_free_trylo T_free_trylo emptyCT).

Definition psi_free_next :=
  consCT L_free_tryhi T_free_tryhi (
  consCT L_free_iter T_free_iter emptyCT).

Definition psi_free_tryhi :=
  consCT L_free_notjhi T_free_notjhi (
  consCT L_free_trylo T_free_trylo emptyCT).

Definition psi_free_notjhi := consCT L_free_trylo T_free_trylo emptyCT.

Definition psi_free_trylo := 
  consCT L_free_lnklo T_free_lnklo (
  consCT L_free_epilog T_free_epilog emptyCT).

Definition psi_free_notjlo :=
  consCT L_free_epilog T_free_epilog emptyCT.

Definition psi_free_lnklo :=
  consCT L_free_notjlo T_free_notjlo (
  consCT L_free_epilog T_free_epilog emptyCT).
(**************************************************************************)

Theorem WF_free_lnklo :
  Infer (itpx2 (itpx1 T_free_lnklo) psi_free_lnklo) C_free_lnklo.
Proof.
unfold T_free_lnklo; unfold psi_free_lnklo; unfold C_free_lnklo.
unfold P_free_lnklo; unfold G_free_lnklo.
(** lw t0 prev size **)
apply WF_lw with 
  (fun s : state => FREE_FRAME s /\ getValinR s prev < getValinR s hp /\ getValinR s prev 
    <> pnil /\ getValinR s ra <> 0 /\
    exists flistv : addr, exists lnk : addr, exists n : nat, exists m : nat, exists siz,
      (star (MBlkLst (S n) (getValinR s hp) pnil) (star (pto flist flistv) (
	star (star (MBlkLst m flistv (getValinR s prev)) 
	    (MBlk (getValinR s prev + 2) lnk siz)) (star (Stk TOP) arbh)))) s /\
      getValinR s t0 = siz)
  (fun s s' : state => POPS0S1S2 s s' /\ Gand ES0S1S2 ET0T1T2 s s' /\ RESRqd s s' /\
    HIntact TOP (getValinR s fp) s s' /\ forall others : assert, RfInsA others ->
      (exists flistv : addr, exists lnk : addr, exists n : nat, exists m : nat, exists siz,  	
	(star (MBlkLst (S n) (getValinR s hp) pnil) (star (pto flist flistv) (
	  star (star (MBlkLst m flistv (getValinR s prev))
	    (MBlk (getValinR s prev + 2) lnk siz)) (star (Stk TOP) others)))) s
	/\ getValinR s t0 = siz) ->
      (exists flistv : addr, (star (pto flist flistv) (
	star (Good flistv) (star (Stk TOP) others))) s')).
(** prev->size indom **)
intros. splitland. splitex. repeat splitstar. inrh. inrh. inlh. inrh. mblkindom.
(** P S -> P' nextS **)
unfold FREE_FRAME. intros. induction s as [h rf]. inversion H0. simplRf'; simplRf H.
splitland; getland. splitex. exists x0; exists x1; exists x2; exists x3; exists x4. 
split; repeat (intros; rfinsen). repeat splitstar. 
assert (x = hread' h (lookupR rf prev + 1)). unfold hread'. rewrite H7; trivial.
rewrite H28. unfold hread'. hread2. readrh. hread2. readrh. hread2. readlh. hread2.
readrh. foldhread'. mblkchunk. mblkindom. fauto. inrh. mblkindom. inlh. inrh. 
mblkindom. inrh. inlh. inrh. mblkindom.
(** P S -> G' nextS S -> G S S' **)
unfold RESRqd. intros. induction s as [h rf]. induction s'' as [h'' rf''].
inversion H0. rewrite <- H3 in H1. free_unall H1. simplRf'; simplRf H1. 
intuition. clear H19. apply H23; auto. unfold RfInsA in H31. splitex.
exists x0; exists x1; exists x2; exists x3; exists x4. split. repeat (intros; rfinsen).
intros; apply H31 with rf; auto. repeat splitstar. 
assert (x = hread' h (lookupR rf prev + 1)). unfold hread'. rewrite H8; trivial.
rewrite H47. unfold hread'. hread2. readrh. hread2. readrh. hread2. readlh. hread2.
readrh. foldhread'. mblkchunk. mblkindom. fauto. inrh. mblkindom. inlh. inrh. 
mblkindom. inrh. inlh. inrh. mblkindom.
(** addu t1 prev t0 **) 
apply WF_addu with
    (fun s : state => FREE_FRAME s /\ getValinR s prev < getValinR s hp /\ 
      getValinR s prev <> pnil /\ getValinR s ra <> 0 /\
    exists flistv : addr, exists lnk : addr, exists n : nat, exists m : nat, exists siz,
      (star (MBlkLst (S n) (getValinR s hp) pnil) (star (pto flist flistv) (
	star (star (MBlkLst m flistv (getValinR s prev)) 
	    (MBlk (getValinR s prev + 2) lnk siz)) (star (Stk TOP) arbh)))) s /\
      getValinR s t0 = siz /\ getValinR s t1 = getValinR s prev + siz)
  (fun s s' : state => POPS0S1S2 s s' /\ Gand ES0S1S2 ET0T1T2 s s' /\ RESRqd s s' /\
    HIntact TOP (getValinR s fp) s s' /\ forall others : assert, RfInsA others ->
      (exists flistv : addr, exists lnk : addr, exists n : nat, exists m : nat, exists siz,  	
	(star (MBlkLst (S n) (getValinR s hp) pnil) (star (pto flist flistv) (
	  star (star (MBlkLst m flistv (getValinR s prev))
	    (MBlk (getValinR s prev + 2) lnk siz)) (star (Stk TOP) others)))) s
	/\ getValinR s t0 = siz /\ getValinR s t1 = getValinR s prev + siz) ->
      (exists flistv : addr, (star (pto flist flistv) (
	star (Good flistv) (star (Stk TOP) others))) s')).
(** P S -> P' nextS **)
unfold FREE_FRAME. intros. induction s as [h rf]. inversion H0. simplRf'; simplRf H.
splitland; getland. splitex. exists x; exists x0; exists x1; exists x2; exists x3.
inversion_clear H12. split; repeat (intros; rfinsen). getland.
(** P S -> G' nextS S' -> G S S' **)
unfold RESRqd. intros. induction s as [h rf]. induction s'' as [h'' rf''].
inversion H0. rewrite <- H2 in H1. free_unall H1. simplRf'; simplRf H1. clear H.
splitland; getland. intros. apply H11; auto. splitex.
exists x; exists x0; exists x1; exists x2; exists x3.
inversion_clear H28. getland. repeat (intros; rfinsen).
unfold RfInsA in H25; intros; apply H25 with rf; auto.
(**bne hp t1 L_free_notjlo **)
apply WF_bne with P_free_notjlo
  (fun s : state => FREE_FRAME s /\ getValinR s prev < getValinR s hp /\ 
    getValinR s prev <> pnil /\ getValinR s ra <> 0 /\
    exists flistv : addr, exists lnk : addr, exists n : nat, exists m : nat, exists siz,
      (star (MBlkLst (S n) (getValinR s hp) pnil) (star (pto flist flistv) (
	star (star (MBlkLst m flistv (getValinR s prev)) 
	    (MBlk (getValinR s prev + 2) lnk siz)) (star (Stk TOP) arbh)))) s /\
      getValinR s t0 = siz /\ getValinR s hp = getValinR s prev + siz)
  G_free_notjlo
  (fun s s' : state => POPS0S1S2 s s' /\ Gand ES0S1S2 ET0T1T2 s s' /\ RESRqd s s' /\
    HIntact TOP (getValinR s fp) s s' /\ forall others : assert, RfInsA others ->
      (exists flistv : addr, exists lnk : addr, exists n : nat, exists m : nat, exists siz,  	
	(star (MBlkLst (S n) (getValinR s hp) pnil) (star (pto flist flistv) (
	  star (star (MBlkLst m flistv (getValinR s prev))
	    (MBlk (getValinR s prev + 2) lnk siz)) (star (Stk TOP) others)))) s
	/\ getValinR s t0 = siz /\ getValinR s hp = getValinR s prev + siz) ->
      (exists flistv : addr, (star (pto flist flistv) (
	star (Good flistv) (star (Stk TOP) others))) s')).
(**psi (f) = theta **)
unfold T_free_notjlo; constructor.
(** hp <> t1 -> P => P' **) Focus 2.
unfold P_free_notjlo. intros. simplRf H; simplRf'. splitland; getland.
splitex. splitland. rewrite H7 in H0. rewrite H4. 
do 2 (starassocr x). splitstar. clear H10. starrev H8. starassocl H9.
splitstar. starassocr H12. splitstar. assert (lookupR rf prev + x3 <= lookupR rf hp).
splitstar. mblklonotoverlap. omega. splitex. splitland. rewrite H4.
exists x; exists x0; exists x1; exists x2. trivial.
(** hp <> t1 -> P => G' => G **) Focus 2.
unfold G_free_notjlo. unfold RESRqd. intros. simplRf'; simplRf H1. splitland; getland.
intros. clear H12. apply H6; auto. splitex. splitland. rewrite H12. exists x; exists x0;
exists x1; exists x2. trivial.
(** hp = t1 -> P => P''**) Focus 2.
intros. splitland. simplRf'; simplRf H5. getland. rewrite H0. rewrite H0 in H5. trivial.
(** hp = t1 -> P => G'' => G **) Focus 2.
intros. simplRf'; simplRf H1. clear H. rewrite H0. rewrite H0 in H1. splitland; getland. 
(** lw t2 hp size **)
apply WF_lw with 
  (fun s : state => FREE_FRAME s /\ getValinR s prev < getValinR s hp /\ 
    getValinR s prev <> pnil /\ getValinR s ra <> 0 /\ 
    exists flistv : addr, exists lnk : addr, exists n : nat, exists m : nat, exists siz,
      exists lptr : addr, exists siz' : nat,
      (star (star (MBlk (getValinR s hp + 2) lptr siz')(MBlkLst n lptr pnil) )
	(star (pto flist flistv) (star (star (MBlkLst m flistv (getValinR s prev)) 
	    (MBlk (getValinR s prev + 2) lnk siz)) (star (Stk TOP) arbh)))) s /\
      getValinR s t0 = siz /\ getValinR s hp = getValinR s prev + siz /\ 
      getValinR s t2 = siz' /\ (getValinR s hp < lptr \/ lptr = pnil))
  (fun s s' : state => POPS0S1S2 s s' /\ Gand ES0S1S2 ET0T1T2 s s' /\ RESRqd s s' /\
    HIntact TOP (getValinR s fp) s s' /\ forall others : assert, RfInsA others ->
      (exists flistv : addr, exists lnk : addr, exists n : nat, exists m : nat, exists siz,  	
	exists lptr : addr, exists siz' : addr, 
	  (star (star (MBlk (getValinR s hp + 2) lptr siz')(MBlkLst n lptr pnil))
	    (star (pto flist flistv) (star (star (MBlkLst m flistv (getValinR s prev))
	      (MBlk (getValinR s prev + 2) lnk siz)) (star (Stk TOP) others)))) s
	  /\ getValinR s t0 = siz /\ getValinR s hp = getValinR s prev + siz 
	  /\ getValinR s t2 = siz' /\ (getValinR s hp < lptr \/ lptr = pnil)) ->
      (exists flistv : addr, (star (pto flist flistv) (
	star (Good flistv) (star (Stk TOP) others))) s')).
(** hp->size in dom **)
intros. simplRf H. splitland. splitex. splitland. repeat splitstar. 
inlh. inversion H7. inlh. mblkindom.
(** P S -> P' nextS **)
unfold FREE_FRAME. intros. induction s as [h rf]. inversion H0.
simplRf H; simplRf'. splitland; getland. splitex. splitland.
exists x0; exists x1; exists x2; exists x3; exists x4. repeat splitstar.
inversion_clear H17. exists p'; exists n. getland. getstar'. getstar'.
rfinsen. rfinsen. repeat getstar'. rfinsen. rfinsen. rfinsen.
assert (hread' h (lookupR rf hp + 1) = x). unfold hread'. rewrite H7; trivial.
rewrite <- H17. unfold hread'. hread2. readlh. hread2. readlh. foldhread'.
mblkchunk. fauto.  mblkindom. fauto. inlh. mblkindom.
(** P S -> G' nextS S' -> G S S' **)
unfold RESRqd. intros. induction s as [h rf]. induction s'' as [h'' rf''].
inversion H0. clear H. rewrite <- H3 in H1. free_unall H1. simplRf H1; simplRf'.
splitland; getland. intros; apply H12; auto. splitex. splitland.
exists x0; exists x1; exists x2; exists x3; exists x4. repeat splitstar.
inversion_clear H32. exists p'; exists n. getland. getstar'. getstar'.
rfinsen. rfinsen. repeat getstar'. rfinsen. rfinsen. rfinsen.
unfold RfInsA in H26. apply H26 with rf; auto.  assert (hread' h (lookupR rf hp + 1) = x). 
unfold hread'. rewrite H8; trivial. rewrite <- H32. unfold hread'. 
hread2. readlh. hread2. readlh. foldhread'.
mblkchunk. fauto.  mblkindom. fauto. inlh. mblkindom.
(** addu t1 t0 t2 **)
apply WF_addu with 
  (fun s : state => FREE_FRAME s /\ getValinR s prev < getValinR s hp /\ 
    getValinR s prev <> pnil /\ getValinR s ra <> 0 /\ 
    exists flistv : addr, exists lnk : addr, exists n : nat, exists m : nat, exists siz,
      exists lptr : addr, exists siz' : nat,
      (star (star (MBlk (getValinR s hp + 2) lptr siz')(MBlkLst n lptr pnil) )
	(star (pto flist flistv) (star (star (MBlkLst m flistv (getValinR s prev)) 
	    (MBlk (getValinR s prev + 2) lnk siz)) (star (Stk TOP) arbh)))) s /\
      getValinR s t1 = siz + siz' /\ getValinR s hp = getValinR s prev + siz
       /\ (getValinR s hp < lptr \/ lptr = pnil))
  (fun s s' : state => POPS0S1S2 s s' /\ Gand ES0S1S2 ET0T1T2 s s' /\ RESRqd s s' /\
    HIntact TOP (getValinR s fp) s s' /\ forall others : assert, RfInsA others ->
      (exists flistv : addr, exists lnk : addr, exists n : nat, exists m : nat, exists siz,  	
	exists lptr : addr, exists siz' : addr, 
	  (star (star (MBlk (getValinR s hp + 2) lptr siz')(MBlkLst n lptr pnil))
	    (star (pto flist flistv) (star (star (MBlkLst m flistv (getValinR s prev))
	      (MBlk (getValinR s prev + 2) lnk siz)) (star (Stk TOP) others)))) s
	  /\ getValinR s t1 = siz + siz' /\ getValinR s hp = getValinR s prev + siz 
	  /\ (getValinR s hp < lptr \/ lptr = pnil)) ->
      (exists flistv : addr, (star (pto flist flistv) (
	star (Good flistv) (star (Stk TOP) others))) s')).
(** P S -> P' nextS **)
unfold FREE_FRAME. intros. induction s as [h rf]. inversion H0. simplRf'; simplRf H.
splitland; getland. splitex. splitland. exists x; exists x0; exists x1; exists x2;
exists x3; exists x4; exists x5. getland. repeat (intros; rfinsen). 
(** P S -> G' nextS S '-> G S S' **)
unfold RESRqd. intros. clear H. induction s as [h rf]. induction s'' as [h'' rf''].
inversion H0. free_unall H1. rewrite <- H5 in H1. simplRf'; simplRf H1. 
splitland; getland. intros. apply H11; auto. splitex. splitland. exists x; exists x0;
exists x1; exists x2; exists x3; exists x4; exists x5. getland. 
repeat (intros; rfinsen). unfold RfInsA in H25; intros; apply H25 with rf; auto.
(**lw t0 hp next **)
apply WF_lw with 
  (fun s : state => FREE_FRAME s /\ getValinR s prev < getValinR s hp /\ 
    getValinR s prev <> pnil /\ getValinR s ra <> 0 /\ 
    exists flistv : addr, exists lnk : addr, exists n : nat, exists m : nat, exists siz,
      exists lptr : addr, exists siz' : nat,
      (star (star (MBlk (getValinR s hp + 2) lptr siz')(MBlkLst n lptr pnil) )
	(star (pto flist flistv) (star (star (MBlkLst m flistv (getValinR s prev)) 
	    (MBlk (getValinR s prev + 2) lnk siz)) (star (Stk TOP) arbh)))) s /\
      getValinR s t1 = siz + siz' /\ getValinR s hp = getValinR s prev + siz
       /\ (getValinR s hp < lptr \/ lptr = pnil) /\ getValinR s t0 = lptr)
  (fun s s' : state => POPS0S1S2 s s' /\ Gand ES0S1S2 ET0T1T2 s s' /\ RESRqd s s' /\
    HIntact TOP (getValinR s fp) s s' /\ forall others : assert, RfInsA others ->
      (exists flistv : addr, exists lnk : addr, exists n : nat, exists m : nat, exists siz,  	
	exists lptr : addr, exists siz' : addr, 
	  (star (star (MBlk (getValinR s hp + 2) lptr siz')(MBlkLst n lptr pnil))
	    (star (pto flist flistv) (star (star (MBlkLst m flistv (getValinR s prev))
	      (MBlk (getValinR s prev + 2) lnk siz)) (star (Stk TOP) others)))) s
	  /\ getValinR s t1 = siz + siz' /\ getValinR s hp = getValinR s prev + siz 
	  /\ (getValinR s hp < lptr \/ lptr = pnil) /\ getValinR s t0 = lptr) ->
      (exists flistv : addr, (star (pto flist flistv) (
	star (Good flistv) (star (Stk TOP) others))) s')).
(** hp->next in dom **)
intros. simplRf H. splitland. splitex. splitland. repeat splitstar. simpl0p.
inlh. inlh. mblkindom. 
(** P S -> P' next S **)
unfold FREE_FRAME. intros. induction s as [h rf]. inversion H0. simplRf H; simplRf'.
splitland; getland. splitex. splitland. exists x0; exists x1; exists x2; exists x3;
exists x4; exists x5; exists x6. getland. repeat (intros; rfinsen).
assert (hread' h (lookupR rf hp + 0) = x). unfold hread'. rewrite H7; trivial.
rewrite <- H16. simpl0p. unfold hread'. repeat splitstar. hread2. readlh. hread2. readlh.
foldhread'. mblkchunk. fauto. mblkindom. fauto. inlh. mblkindom. 
(** P S -> G' nextS S' -> G S S' **)
unfold RESRqd. intros. free_unall H1. induction s as [h rf]. induction s'' as [h'' rf''].
inversion H0. rewrite <- H3 in H1. simplRf H1; simplRf'. splitland. getland. intros.
clear H32. apply H13; auto. splitex. splitland. exists x0; exists x1; exists x2; exists x3;
exists x4; exists x5; exists x6. getland. repeat (intros; rfinsen). 
unfold RfInsA in H31; intros; apply H31 with rf; auto.
assert (hread' h (lookupR rf hp + 0) = x). unfold hread'. rewrite H8; trivial.
rewrite <- H35. simpl0p. unfold hread'. repeat splitstar. hread2. readlh. hread2. readlh.
foldhread'. mblkchunk. fauto. mblkindom. fauto. inlh. mblkindom. 
(** sw prev size t1 **)
apply WF_sw with 
  (fun s : state => FREE_FRAME s /\ getValinR s prev < getValinR s hp /\ 
    getValinR s prev <> pnil /\ getValinR s ra <> 0 /\ 
    exists flistv : addr, exists lnk : addr, exists n : nat, exists m : nat, 
      exists siz, exists lptr : addr, 
	(star (MBlkLst n lptr pnil)
	  (star (pto flist flistv) (star (star (MBlkLst m flistv (getValinR s prev)) 
	    (MBlk (getValinR s prev + 2) lnk siz)) (star (Stk TOP) arbh)))) s /\
      (getValinR s hp < lptr \/ lptr = pnil) /\ getValinR s t0 = lptr)
  (fun s s' : state => POPS0S1S2 s s' /\ Gand ES0S1S2 ET0T1T2 s s' /\ RESRqd s s' /\
    HIntact TOP (getValinR s fp) s s' /\ forall others : assert, RfInsA others ->
      (exists flistv : addr, exists lnk : addr, exists n : nat, exists m : nat, 
	exists siz, exists lptr : addr, 
	  (star (MBlkLst n lptr pnil)
	    (star (pto flist flistv) (star (star (MBlkLst m flistv (getValinR s prev))
	      (MBlk (getValinR s prev + 2) lnk siz)) (star (Stk TOP) others)))) s
	  /\ (getValinR s hp < lptr \/ lptr = pnil) /\ getValinR s t0 = lptr) ->
      (exists flistv : addr, (star (pto flist flistv) (
	star (Good flistv) (star (Stk TOP) others))) s')).
(** prev->size in dom **)
intros. splitland. splitex. splitland. simplRf H4. repeat splitstar.
inrh. inrh. inlh. inrh. mblkindom.
(** P S -> P' nextS **)
unfold FREE_FRAME. intros. induction s as [h rf]. inversion H0. simplRf H; simplRf'.
splitland; getland. splitex. splitland. exists x; exists x0; exists x1; exists x2;
exists (x3 + x5); exists x4. getland. starrev H12. starassocr H17. starrev H12.
splitstar. writerh. repeat splitstar. inlh.  inrh. inlh. inrh. mblkindom.
starassocl H21. splitstar. writerh. repeat splitstar. inlh. inlh. inrh. mblkindom.
starrev H23. starassocr H20. splitstar. writelh. clear H25. repeat splitstar.
inrh. inrh. mblkindom. clear H25. starrev H23. starassocl H20. splitstar.
writerh. splitstar. inlh. mblkindom. rewrite H13. splitstar. 
assert (hread' x14 (lookupR rf prev + 1) = x3). mblkchunk.
assert (hread' x15 (lookupR rf hp + 1) = x5). mblkchunk.
rewrite <- H27; rewrite <- H29. mblk3.
(** P S -> G' nextS S' -> G S S' **)
unfold FREE_FRAME. intros. induction s as [h rf]. induction s'' as [h'' rf''].
inversion H0. rewrite <- H3 in H1. free_unall H1. simplRf'; simplRf H; simplRf H1.
splitland. splitex. splitland. do 2 splitstar. starassocl H44. splitstar.
starassocr H47. do 2 splitstar. getland. rewrite H25. ungetVinH. simplneq.
apply beq_neq_false. apply disj_indom_neq with x14 x15; auto. mblkindom. stkindom.
rewrite H9. ungetVinH. simplneq. apply beq_neq_false. apply disj_indom_neq with x14 x15;
auto. mblkindom. stkindom. rewrite H28. ungetVinH. simplneq.
apply beq_neq_false. apply disj_indom_neq with x14 x15; auto. mblkindom. stkindom.
rewrite H12. ungetVinH. simplneq. apply beq_neq_false. apply disj_indom_neq with x14 x15; 
auto. mblkindom. stkindom. hintact'. notinstk. mblkindom. fromnotinstk. inversion_clear H54.
left; omega. right; trivial. intros. clalldisj. clallheq. clallha. clallh.
splitex. splitland. apply H13; auto. exists x7; exists x8; exists x9; exists x11;
exists (x12 + x14); exists x13. getland. starrev H37. starassocr H42. starrev H37.
splitstar. writerh. repeat splitstar. inlh.  inrh. inlh. inrh. mblkindom.
starassocl H47. splitstar. writerh. repeat splitstar. inlh. inlh. inrh. mblkindom.
starrev H49. starassocr H46. splitstar. writelh. clear H51. repeat splitstar.
inrh. inrh. mblkindom. clear H51. starrev H49. starassocl H46. splitstar.
writerh. splitstar. inlh. mblkindom. rewrite H32. splitstar. 
assert (hread' x23 (lookupR rf prev + 1) = x12). mblkchunk.
assert (hread' x24 (lookupR rf hp + 1) = x14). mblkchunk.
rewrite <- H54; rewrite <- H56. mblk3.
(** sw prev next t0 **)
apply WF_sw with
  (fun s : state => FREE_FRAME s /\ getValinR s prev < getValinR s hp /\ 
    getValinR s prev <> pnil /\ getValinR s ra <> 0 /\ 
    exists flistv : addr, exists n : nat, exists m : nat, 
      exists siz, exists lptr : addr, 
	(star (MBlkLst n lptr pnil)
	  (star (pto flist flistv) (star (star (MBlkLst m flistv (getValinR s prev)) 
	    (MBlk (getValinR s prev + 2) lptr siz)) (star (Stk TOP) arbh)))) s /\
	(getValinR s hp < lptr \/ lptr = pnil))
  (fun s s' : state => POPS0S1S2 s s' /\ Gand ES0S1S2 ET0T1T2 s s' /\ RESRqd s s' /\
    HIntact TOP (getValinR s fp) s s' /\ forall others : assert, RfInsA others ->
      (exists flistv : addr, exists n : nat, exists m : nat, 
	exists siz, exists lptr : addr, 
	  (star (MBlkLst n lptr pnil)
	    (star (pto flist flistv) (star (star (MBlkLst m flistv (getValinR s prev))
	      (MBlk (getValinR s prev + 2) lptr siz)) (star (Stk TOP) others)))) s
	  /\ (getValinR s hp < lptr \/ lptr = pnil)) ->
      (exists flistv : addr, (star (pto flist flistv) (
	star (Good flistv) (star (Stk TOP) others))) s')).
(** prev->next in dom **)
intros. simplRf H. simpl0p. splitland. splitex. splitland. repeat splitstar.
inrh. inrh. inlh. inrh. mblkindom.
(** P S -> P' nextS **)
unfold FREE_FRAME. intros. induction s as [h rf]. inversion H0. simplRf H; simplRf'.
splitland; getland. splitex. splitland. exists x; exists x1; exists x2; exists x3;
exists x4. getland. rewrite H16. simpl0p. splitstar. writerh. repeat splitstar.
inrh. inlh. inrh. mblkindom. splitstar. writerh. repeat splitstar. inlh. inrh.
mblkindom. splitstar. writelh. clear H23. splitstar. inrh. mblkindom.
clear H23. splitstar. writerh. mblkindom. mblklnk.
(** P S -> G' nextS S' -> G S S' **)
unfold FREE_FRAME. intros. induction s as [h rf]. induction s'' as [h'' rf''].
free_unall H1. inversion H0. rewrite <- H3 in H1. simplRf'; simplRf H; simplRf H1. 
splitland. splitex. splitland. do 2 splitstar. starassocl H42. splitstar.
starassocr H45. do 2 splitstar. getland. rewrite H25. ungetVinH.
simplneq. apply beq_neq_false. apply disj_indom_neq with x13 x14; auto.
simpl0p. mblkindom. stkindom. rewrite H9 . ungetVinH.
simplneq. apply beq_neq_false. apply disj_indom_neq with x13 x14; auto.
simpl0p. mblkindom. stkindom. rewrite H28. ungetVinH.
simplneq. apply beq_neq_false. apply disj_indom_neq with x13 x14; auto.
simpl0p. mblkindom. stkindom. rewrite H12. ungetVinH.
simplneq. apply beq_neq_false. apply disj_indom_neq with x13 x14; auto.
simpl0p. mblkindom. stkindom. hintact'. notinstk. simpl0p. mblkindom.
fromnotinstk. inversion H52. left; rewrite H53; omega. right; auto.
intros; apply H13; auto. clalldisj. clallheq. clallha. clallh.
splitex. splitland. exists x6; exists x8; exists x10; exists x11;
exists x12. getland. rewrite H39. simpl0p. splitstar. writerh. repeat splitstar.
inrh. inlh. inrh. mblkindom. splitstar. writerh. repeat splitstar. inlh. inrh.
mblkindom. splitstar. writelh. clear H47. splitstar. inrh. mblkindom.
clear H47. splitstar. writerh. mblkindom. mblklnk.
(** j L_free_epilog **)
apply WF_j with P_free_epilog G_free_epilog. 
(** psi (f) = theta **)
constructor. constructor. auto.
(** P => P'  ***)
unfold P_free_epilog. intros. splitland. getland. splitex. 
splitland. exists x. starrev H4. starassocl H3. induction s as [h rf].
splitstar. getstar'. starrev H8. starassocr H7. splitstar. getstar'.
clear H11. starrev H9. splitstar. splitstar.
assert (MBlkLst (S x1) x x3 (x8, rf)).
apply MBlkLst_MBlk_MBlkLst with (getValinR (h, rf) prev) x10 x11 x2; auto.
omega. clear H14; clear H16. unfold Good. exists (S x1 + x0).
apply MBlkLst3 with x8 x9 x3; auto. 
(** P => G' => G **)
unfold G_free_epilog. intros. splitland. getland. intros.
clear H9. apply H5; auto. splitex. splitland. exists x. starrev H10.
starassocl H9. induction s as [h rf].
splitstar. getstar'. starrev H14. starassocr H13. splitstar. getstar'.
clear H17. starrev H15. splitstar. splitstar.
assert (MBlkLst (S x1) x x3 (x8, rf)).
apply MBlkLst_MBlk_MBlkLst with (getValinR (h, rf) prev) x10 x11 x2; auto.
omega. clear H20; clear H22. unfold Good. exists (S x1 + x0).
apply MBlkLst3 with x8 x9 x3; auto. 
Save.

(*********************************************************************)

Theorem WF_free_notjlo :
  Infer (itpx2 (itpx1 T_free_notjlo) psi_free_notjlo) C_free_notjlo.
Proof.
unfold T_free_notjlo; unfold C_free_notjlo; unfold psi_free_notjlo.
unfold P_free_notjlo; unfold G_free_notjlo.
(**sw prev next hp **)
apply WF_sw with P_free_epilog G_free_epilog.
(** prev->next is in dom **)
intros. simpl0p. simplRf H. splitland. splitex. repeat splitstar.
inrh. inrh. inlh. inrh. mblkindom.
(** P S -> P' nextS **)
unfold P_free_epilog. unfold FREE_FRAME. intros. induction s as [h rf].
inversion H0. simplRf H; simplRf'. splitland; getland. splitex. exists x.
starrev H13. starassocl H14. splitstar. simpl0p.  writerh. repeat splitstar.
inlh. inlh. inrh. mblkindom. starrev H18. starassocr H14. splitstar. 
writelh. clear H20. repeat splitstar. inrh. inrh. mblkindom. 
clear H20. splitstar. apply AppendGood with x7 x8 x2 (lookupR rf t0) x0 x1; auto.
(** P S -> G' nextS S' -> G S S' **)
unfold FREE_FRAME. unfold G_free_epilog. intros. induction s as [h rf].
induction s'' as [h'' rf'']. inversion H0. rewrite <- H3 in H1. free_unall H1.
simplRf H1; simplRf H; simplRf'. splitland. splitex. do 2 splitstar. starassocl H41.
splitstar. starassocr H44. do 2 splitstar. getland. rewrite H25. ungetVinH. simplneq.
apply beq_neq_false. apply disj_indom_neq with x11 x12; auto. mblkindom. stkindom.
rewrite H9. ungetVinH. simplneq. apply beq_neq_false. apply disj_indom_neq with x11 x12; 
auto. mblkindom. stkindom. rewrite H28. ungetVinH. simplneq. apply beq_neq_false. 
apply disj_indom_neq with x11 x12; auto. mblkindom. stkindom. rewrite H12. ungetVinH. simplneq.
apply beq_neq_false. apply disj_indom_neq with x11 x12; auto. mblkindom. stkindom.
hintact'. notinstk. mblkindom. fromnotinstk. inversion_clear H51. left; omega.
right; trivial. clalldisj. clallheq. clallha. clallh. clear H36; clear H42; clear x7; 
clear x0; clear x1; clear x2; clear x3; clear x. intros. apply H13; auto.
splitex. exists x. starrev H34. starassocl H36. splitstar. simpl0p.  writerh. repeat splitstar.
inlh. inlh. inrh. mblkindom. starrev H39. starassocr H36. splitstar. 
writelh. clear H41. repeat splitstar. inrh. inrh. mblkindom. clear H41. splitstar.
apply AppendGood with x7 x8 x2 (lookupR rf t0) x0 x1; auto.
(** j L_free_epilog **)
apply WF_j with P_free_epilog G_free_epilog.
(* psi(f) = theta **)
constructor.
(** P => P' **)
intros; trivial.
(** P => G' => G **)
intros; trivial.
Save.

(**********************************************************************)

Theorem WF_free_epilog :
  Infer (itpx2 (itpx1 T_free_epilog) emptyCT) C_free_epilog.
Proof.
unfold T_free_epilog; unfold C_free_epilog.
unfold P_free_epilog; unfold G_free_epilog. unfold POPS0S1S2.
(** lw_ p fp 3 **)
apply WF_lw_ with 
  (fun s : state => FREE_FRAME s /\ getValinR s ra <> 0 /\ (exists flistv : nat, 
    star (pto flist flistv) (star (Good flistv) (star (Stk TOP) arbh)) s))
  (fun s s' : state => (getValinR s' hp = getVinH s (getValinR s fp - 1) /\
    getValinR s' prev = getVinH s (getValinR s fp - 2) /\ getValinR s' p = getValinR s p /\
    Gand ES0S1S2 ET0T1T2 s s' /\ RESRqd s s' /\ HIntact TOP (getValinR s fp) s s' /\
    (forall others : assert, RfInsA others -> (exists flistv : nat, star (pto flist flistv)
      (star (Good flistv) (star (Stk TOP) others)) s) -> exists flistv : nat,
    star (pto flist flistv) (star (Good flistv) (star (Stk TOP) others)) s'))).
(** fp - 3 in dom **)
unfold FREE_FRAME. intros. simplRf H. splitland. splitex. repeat splitstar.
inrh. inrh. inlh. stkindom. 
(** P S -> P ' nextS **)
unfold FREE_FRAME. intros.  induction s as [h rf]. inversion H0. 
simplRf'; simplRf H. splitland; getland. splitex. exists x0. repeat (intros; rfinsen).
(** P S -> G' nextS S' -> G S S' **)
unfold RESRqd. intros. free_unall H1. induction s as [h rf]. induction s'' as [h'' rf''].
inversion H0. rewrite <- H3 in H1. simplRf'; simplRf H1. splitland; getland. rewrite H10. 
ungetVinH. foldhread. rewrite H8; auto. intros. apply H15; auto. clear H30. splitex. 
exists x0. repeat (intros; rfinsen). unfold RfInsA in H29; intros; apply H29 with rf; auto.
(** lw_ prev fp 2 **)
apply WF_lw_ with 
  (fun s : state => FREE_FRAME s /\ getValinR s ra <> 0 /\ (exists flistv : nat, 
    star (pto flist flistv) (star (Good flistv) (star (Stk TOP) arbh)) s))
  (fun s s' : state => (getValinR s' hp = getVinH s (getValinR s fp - 1) /\
    getValinR s' prev = getValinR s prev /\ getValinR s' p = getValinR s p /\
    Gand ES0S1S2 ET0T1T2 s s' /\ RESRqd s s' /\ HIntact TOP (getValinR s fp) s s' /\
    (forall others : assert, RfInsA others -> (exists flistv : nat, star (pto flist flistv)
      (star (Good flistv) (star (Stk TOP) others)) s) -> exists flistv : nat,
    star (pto flist flistv) (star (Good flistv) (star (Stk TOP) others)) s'))).
(** fp - 2 in dom **)
unfold FREE_FRAME. intros. simplRf H. splitland. splitex. repeat splitstar.
inrh. inrh. inlh. stkindom. 
(** P S -> P ' nextS **)
unfold FREE_FRAME. intros.  induction s as [h rf]. inversion H0. 
simplRf'; simplRf H. splitland; getland. splitex. exists x0. repeat (intros; rfinsen).
(** P S -> G' nextS S' -> G S S' **)
unfold RESRqd. intros. free_unall H1. induction s as [h rf]. induction s'' as [h'' rf''].
inversion H0. rewrite <- H3 in H1. simplRf'; simplRf H1. splitland; getland. rewrite H1. 
ungetVinH. foldhread. rewrite H8; auto. intros. apply H15; auto. clear H30. splitex. 
exists x0. repeat (intros; rfinsen). unfold RfInsA in H29; intros; apply H29 with rf; auto.
(** lw_ prev fp 1 **)
apply WF_lw_ with 
  (fun s : state => FREE_FRAME s /\ getValinR s ra <> 0 /\ (exists flistv : nat, 
    star (pto flist flistv) (star (Good flistv) (star (Stk TOP) arbh)) s))
  (fun s s' : state => (getValinR s' hp = getValinR s hp 
    /\ getValinR s' prev = getValinR s prev /\ getValinR s' p = getValinR s p /\
    Gand ES0S1S2 ET0T1T2 s s' /\ RESRqd s s' /\ HIntact TOP (getValinR s fp) s s' /\
    (forall others : assert, RfInsA others -> (exists flistv : nat, star (pto flist flistv)
      (star (Good flistv) (star (Stk TOP) others)) s) -> exists flistv : nat,
    star (pto flist flistv) (star (Good flistv) (star (Stk TOP) others)) s'))).
(** fp - 1 in dom **)
unfold FREE_FRAME. intros. simplRf H. splitland. splitex. repeat splitstar.
inrh. inrh. inlh. stkindom. 
(** P S -> P ' nextS **)
unfold FREE_FRAME. intros.  induction s as [h rf]. inversion H0. 
simplRf'; simplRf H. splitland; getland. splitex. exists x0. repeat (intros; rfinsen).
(** P S -> G' nextS S' -> G S S' **)
unfold RESRqd. intros. free_unall H1. induction s as [h rf]. induction s'' as [h'' rf''].
inversion H0. rewrite <- H3 in H1. simplRf'; simplRf H1. splitland; getland. rewrite H9. 
ungetVinH. foldhread. rewrite H8; auto. intros. apply H15; auto. clear H30. splitex. 
exists x0. repeat (intros; rfinsen). unfold RfInsA in H29; intros; apply H29 with rf; auto.
(**lw_ fp fp 0 **)
unfold RESRqd. apply WF_lw with 
  (fun s : state => getValinR s ra <> 0 /\ (exists flistv : nat, star (pto flist flistv)
    (star (Good flistv) (star (Stk TOP) arbh)) s))
  (fun s s' : state => (getValinR s' hp = getValinR s hp  /\ getValinR s' prev = 
    getValinR s prev /\ getValinR s' p = getValinR s p /\ getValinR s' fp = getValinR s fp /\
    getValinR s' sp = getValinR s sp + 4 /\ Gand ES0S1S2 ET0T1T2 s s' /\ 
    HIntact TOP (getValinR s sp + 4) s s' /\ getValinR s' ra = getValinR s ra /\
    (forall others : assert, RfInsA others -> (exists flistv : nat, star (pto flist flistv)
      (star (Good flistv) (star (Stk TOP) others)) s) -> exists flistv : nat,
    star (pto flist flistv) (star (Good flistv) (star (Stk TOP) others)) s'))).
(** fp in dom **)
unfold FREE_FRAME. intros. simplRf H. splitland. splitex. repeat splitstar.
inrh. inrh. inlh. stkindom. 
(** P S -> P ' nextS **)
unfold FREE_FRAME. intros.  induction s as [h rf]. inversion H0. 
simplRf'; simplRf H. splitland; getland. splitex. exists x0. repeat (intros; rfinsen).
(** P S -> G' nextS S' -> G S S' **)
unfold FREE_FRAME; unfold RESRqd. intros. free_unall H1. induction s as [h rf]. 
induction s'' as [h'' rf'']. inversion H0. rewrite <- H3 in H1. simplRf'; simplRf H1; 
simplRf H. splitland; getland. rewrite H11. ungetVinH. simpl0p'. foldhread. 
rewrite H8; auto. rewrite <- H29. apply HIntactInsen with (consR rf fp x).
auto.  intros. apply H17; auto. clear H30. splitex. exists x0. repeat (intros; rfinsen). 
unfold RfInsA in H31; intros; apply H31 with rf; auto.
(**addiu sp sp 4 **)
apply WF_addiu with 
  (fun s : state => getValinR s ra <> 0 /\ (exists flistv : nat, star (pto flist flistv)
    (star (Good flistv) (star (Stk TOP) arbh)) s))
  (fun s s' : state => (getValinR s' hp = getValinR s hp  /\ getValinR s' prev = 
    getValinR s prev /\ getValinR s' p = getValinR s p /\ getValinR s' fp = getValinR s fp /\
    getValinR s' sp = getValinR s sp /\ Gand ES0S1S2 ET0T1T2 s s' /\ 
    HIntact TOP (getValinR s sp) s s' /\ getValinR s' ra = getValinR s ra /\
    (forall others : assert, RfInsA others -> (exists flistv : nat, star (pto flist flistv)
      (star (Good flistv) (star (Stk TOP) others)) s) -> exists flistv : nat,
    star (pto flist flistv) (star (Good flistv) (star (Stk TOP) others)) s'))).
(** P S -> P ' nextS **)
intros.  induction s as [h rf]. inversion H0. simplRf'; simplRf H. intuition.
splitex. exists x. repeat (intros; rfinsen).
(** P S -> G' nextS S' -> G S S' **)
intros. free_unall H1. induction s as [h rf].  induction s'' as [h'' rf'']. 
inversion H0. rewrite <- H2 in H1. simplRf'; simplRf H1. splitland; getland. 
intros. apply H16; auto. clear H28. splitex. exists x. repeat (intros; rfinsen). 
unfold RfInsA in H; intros; apply H with rf; auto.
(** jr ra **)
apply WF_jr_ra'. intros. free_unall H. getland. unfold HIntact. intros. trivial.
intuition.
Save.

(*******************************************************************************)

Theorem WF_free_trylo :
  Infer (itpx2 (itpx1 T_free_trylo) psi_free_trylo) C_free_trylo.
Proof.
unfold psi_free_trylo; unfold C_free_trylo; unfold T_free_trylo.
unfold P_free_trylo; unfold G_free_trylo.
(**bgtz prev L_free_lnklo **)
apply WF_bgtz with P_free_lnklo
  (fun s : state =>getValinR s ra <> 0 /\ FREE_FRAME s /\ getValinR s prev < getValinR s hp /\
    (getValinR s prev = pnil) /\ exists flistv : addr, exists lnk : addr, exists n : nat,
      (star (MBlkLst (S n) (getValinR s hp) pnil) (star (pto flist flistv) (
	  star (EndL flistv pnil lnk) (star (Stk TOP) arbh)))) s)
  G_free_lnklo
  (fun s s' : state => POPS0S1S2 s s' /\ Gand ES0S1S2 ET0T1T2 s s' /\ RESRqd s s' /\
    HIntact TOP (getValinR s fp) s s' /\ (forall others : assert, RfInsA others ->
      (exists flistv : addr, exists lnk : addr, exists n : nat,
	(star (MBlkLst (S n) (getValinR s hp) pnil) (star (pto flist flistv) (
	  star (EndL flistv pnil lnk) (star (Stk TOP) others)))) s) ->
      (exists flistv : addr, (star (pto flist flistv) (star (Good flistv) (
	  star (Stk TOP) others))) s'))).
(*psi(f) = theta **)
constructor. 
(** prev > 0 -> P => P' **) Focus 2.
unfold P_free_lnklo. unfold FREE_FRAME. intros. splitland; getland. simplRf'. omega.
splitex. exists x; exists x0; exists x1. repeat splitstar. unfold EndL in H13.
simplRf H13. inversion_clear H13. 
assert ((lookupR rf prev < x0 \/ x0 = 0) /\ (exists n : nat, (exists m : nat,
  star (MBlkLst m x (lookupR rf prev))(MBlk (lookupR rf prev + 2) x0 n) (x6, rf)))).
apply H19. omega. inversion_clear H13. splitex. exists x11; exists x10. repeat getstar'.
(** prev > 0 -> P => G' => G **) Focus 2.
unfold G_free_lnklo; unfold RESRqd. intros. simplRf'; simplRf H; simplRf H1.
 splitland; getland. clear H13. intros. apply H6. unfold RfInsA; assumption.
splitex. exists x; exists x0; exists x1. repeat splitstar. unfold EndL in H21.
inversion_clear H21. assert ((lookupR rf prev < x0 \/ x0 = 0) /\ (exists n : nat, 
(exists m : nat, star (MBlkLst m x (lookupR rf prev))(MBlk (lookupR rf prev + 2) x0 n) 
(x6, rf)))). apply H27. omega. inversion_clear H21. splitex. exists x11; exists x10. 
repeat getstar'.
(** prev = 0 -> P => P' **) Focus 2.
unfold FREE_FRAME. intros. simplRf H; simplRf'. assert (lookupR rf prev = 0); [omega|idtac].
rewrite H1 in H. intuition.
(** prev = 0 -> P => G' => G **) Focus 2.
unfold RESRqd. intros.  simplRf'; simplRf H1. intuition. apply H11; auto.
assert (lookupR rf prev = 0); [omega | idtac]. rewrite H15 in H14; assumption.
(** sw zero flist hp **)
apply WF_sw with P_free_epilog G_free_epilog.
(** flist in dom **)
intros. splitland. splitex. splitstar. inrh. splitstar. simplz. simpl0p. 
inlh. ptoindom. fauto.
(** P S -> P' nextS **)
unfold P_free_epilog. unfold FREE_FRAME. intros. induction s as [h rf].
inversion H0. simplRf'; simplRf H. splitland; getland. exists (lookupR rf hp).
splitex. simplz. simpl0p. starassocr H13. assocrgoal. splitstar. writelh.
splitstar. fromendl0. assert (heap_eq (happend x4 x5) x5).
apply append_nullheap. apply heap_eq_sym; auto.
revheq' H16. assert (heap_eq x3 x5). heqtrans. revheq' H16.
aeqh. clear H17. splitstar. inrh. ptoindom. clear H17. starrev H15. splitstar.
writelh. unfold Good. exists (S x1); assumption. ptoindom. ptopto. fauto.
(** P S -> P' nextS S' -> G S S' **)
unfold FREE_FRAME. unfold G_free_epilog. unfold RESRqd. intros. induction s as [h rf].
induction s'' as [h'' rf'']. inversion H0. simplz. simpl0p'.
rewrite <- H3 in H1. free_unall H1. simplRf'; simplRf H; simplRf H1.
splitland. splitex. splitstar. starrev H37. starassocl H36. splitstar. starrev H40  .
starassocr H39. splitstar. splitstar. getland. rewrite H25. ungetVinH.
simplneq. apply beq_neq_false. apply disj_indom_neq with x8 x9; auto.
ptoindom. stkindom. rewrite H9. ungetVinH. simplneq. apply beq_neq_false. 
apply disj_indom_neq with x8 x9; auto. ptoindom. stkindom. rewrite H28. ungetVinH.
simplneq. apply beq_neq_false. apply disj_indom_neq with x8 x9; auto.
ptoindom. stkindom. rewrite H12. ungetVinH. simplneq. apply beq_neq_false. 
apply disj_indom_neq with x8 x9; auto. ptoindom. stkindom.  hintact'. notinstk.
ptoindom. fromnotinstk. inversion_clear H47. left; omega. right; trivial.
clalldisj. clallheq. clallha. clallh. intros. apply H13; auto. exists (lookupR rf hp).
splitex. starassocr H36. assocrgoal. splitstar. writelh. splitstar.
fromendl0. assert (heap_eq (happend x9 x10) x10).
apply append_nullheap. apply heap_eq_sym; auto.
revheq' H43. assert (heap_eq x10 x8). heqtrans. 
aeqh. clear H40. splitstar. inrh. ptoindom. clear H40. starrev H37. splitstar.
writelh. unfold Good. exists (S x6); assumption. ptoindom. ptopto. fauto.
(** j L_free_epilog **)
unfold T_free_epilog. apply WF_j with P_free_epilog G_free_epilog.
constructor; [constructor; auto | auto].
(** P => P' **)
intros; trivial.
(** G => G' **)
intros; trivial.
Save.

(******************************************************************)

Theorem WF_free_notjhi :
  Infer (itpx2 (itpx1 T_free_notjhi) psi_free_notjhi) C_free_notjhi.
Proof. 
unfold psi_free_notjhi; unfold C_free_notjhi; unfold T_free_notjhi.
unfold P_free_notjhi; unfold G_free_notjhi. 
(** sw hp next p **)
apply WF_sw with P_free_trylo G_free_trylo.
(** hp->next in dom **)
intros. simplRf H. splitland. splitex. inversion_clear H2. splitstar.
simpl0p. inlh. mblkindom.
(** P S -> P' nextS *)
unfold P_free_trylo. unfold FREE_FRAME. intros. induction s as [h rf].
inversion H0. simplRf H; simplRf'. intuition. splitex. inversion_clear H11.
exists x; exists (lookupR rf p). starassocr H12. starassocr H11. splitstar. 
move H15 after H17. starrev H15. starassocr H16. splitstar. splitstar. 
unfold MidL in H21. splitex. exists x8. splitstar. do 2 assocrgoal.
move H11 after H26. writelh.  inlh. inrh. simpl0p. mblkindom. starrev'.
assocrgoal. move H16 after H26.  writelh. inrh. simpl0p. mblkindom.
assert (hdisj x9 (happend x7 x10)). apply disj_append_L. split; [idtac | assumption].
revdisj. nephewhdisj. writerh. apply cross_happend with x6; auto. 
simpl0p; apply append_preserve_indom_L; mblkindom. assert (hdisj x7 x10).
nephewhdisj. simpl0p. apply CMBlkMBlkLst with x7 x10 x0 x1; auto. 
apply heap_eq_refl. trivial. left; omega. 
(** P S -> G' nextS S' -> G S S' **)
unfold FREE_FRAME. intros. induction s as [h rf]. induction s'' as [h'' rf''].
unfold G_free_trylo in H1. inversion H0. rewrite <- H3 in H1. free_unall H1.
simplRf H; simplRf H1; simplRf'. splitland. splitex. inversion_clear H32.
starrev H31. starassocl H32. splitstar. starassocl H37. splitstar. starrev H40.
starassocr H39. splitstar. splitstar.  getland. rewrite H25. ungetVinH. simplneq. 
apply beq_neq_false. simpl0p. apply disj_indom_neq with x8 x9; auto. mblkindom. stkindom.
rewrite H9. ungetVinH. simplneq.  apply beq_neq_false. simpl0p.
apply disj_indom_neq with x8 x9; auto. mblkindom. stkindom. rewrite H28. ungetVinH. 
simplneq. apply beq_neq_false. simpl0p. apply disj_indom_neq with x8 x9; auto. 
mblkindom. stkindom. rewrite H10. ungetVinH. simplneq. apply beq_neq_false. simpl0p.
apply disj_indom_neq with x8 x9; auto. mblkindom. stkindom. hintact'. simpl0p.
notinstk. mblkindom. fromnotinstk. inversion_clear H47. left; omega. right; assumption.
intros. apply H15. unfold RfInsA in H45. assumption. clalldisj. clallheq. clallha. clallh.
splitex. exists x2; exists (lookupR rf p). starassocr H31. starassocr H32. splitstar. 
move H35 after H37. starrev H35. starassocr H36. splitstar. splitstar. 
unfold MidL in H41. splitex. exists x11. splitstar. do 2 assocrgoal.
move H32 after H47. writelh.  inlh. inrh. simpl0p. mblkindom. starrev'.
assocrgoal. move H36 after H47.  writelh. inrh. simpl0p. mblkindom.
assert (hdisj x12 (happend x10 x13)). apply disj_append_L. split; [idtac | assumption].
revdisj. nephewhdisj. writerh. apply cross_happend with x9; auto. 
simpl0p; apply append_preserve_indom_L; mblkindom. assert (hdisj x10 x13).
nephewhdisj. simpl0p. cblkblklst; auto. apply heap_eq_refl. left. omega.
(** j L_free_trylo **)
apply WF_j with P_free_trylo G_free_trylo.
(** psi (f) = theta **)
constructor.
(** P => P' **)
intros; assumption.
(** P => G' => G **)
intros; assumption.
Save.

(**************************************************************)

Theorem WF_free_tryhi :
  Infer (itpx2 (itpx1 T_free_tryhi) psi_free_tryhi) C_free_tryhi.
Proof.
unfold C_free_tryhi; unfold psi_free_tryhi; unfold T_free_tryhi.
unfold P_free_tryhi; unfold G_free_tryhi.
(** lw t0 hp size **)
apply WF_lw with 
  (fun s : state => getValinR s ra <> 0 /\ FREE_FRAME s /\ 
    getValinR s prev < getValinR s hp /\ getValinR s p <> pnil /\
    getValinR s hp < getValinR s p /\ getValinR s t0 = getVinH s ((getValinR s hp) + 1) /\
    exists flistv : addr, exists lnk : addr, exists siz : nat,
      (star (MBlk ((getValinR s hp) + 2) lnk siz) (star (pto flist flistv) (
	star (MidL flistv (getValinR s prev) (getValinR s p)) (star (Stk TOP) arbh)))) s)
  (fun s : state => 
    fun s' : state => 
      POPS0S1S2 s s' /\ Gand ES0S1S2 ET0T1T2 s s' /\ RESRqd s s' /\ HIntact TOP 
      (getValinR s fp) s s' /\ forall others : assert, RfInsA others  ->
	(exists flistv : addr, exists lnk : addr, exists siz : nat, 	
	  (star (MBlk ((getValinR s hp) + 2) lnk siz) (star (pto flist flistv) (star 
	    (MidL flistv (getValinR s prev) (getValinR s p)) (star (Stk TOP) others)))) s) ->
	(exists flistv : addr, (star (pto flist flistv) (star (Good flistv) (
	  star (Stk TOP) others))) s')).
(** hp+1 in dom **)
intros. splitland. splitex. splitstar. inlh. mblkindom.
(** P S-> P' nextS **)
unfold FREE_FRAME. intros. induction s as [h rf]. inversion H0. simplRf'; simplRf H.
intuition. ungetVinH. unfold hread in H7. rewrite H7; trivial. splitex. exists x0;
exists x1; exists x2. repeat (intros; rfinsen). 
(** P S -> G' nextS S' -> G S S' **)
intros. free_unall H1. induction s as [h rf]. induction s'' as [h'' rf''].
inversion H0. rewrite <- H3 in H1. simplRf'; simplRf H1. unfold getVinH in H1;
unfold getVinH. unfold getValinH; unfold getValinH in H1. intuition. clear H24.
apply H23; auto. splitex. exists x0; exists x1; exists x2. repeat (intros; rfinsen).
unfold RfInsA in H32. intros; apply H32 with rf; auto.
(**addu t1 hp t0 **)
apply WF_addu with 
  (fun s : state => getValinR s ra <> 0 /\ 
    FREE_FRAME s /\ getValinR s prev < getValinR s hp /\ getValinR s p <> pnil /\
    getValinR s hp < getValinR s p /\ getValinR s t0 = getVinH s ((getValinR s hp) + 1)
    /\ getValinR s t1 = getValinR s hp + getValinR s t0 /\
    exists flistv : addr, exists lnk : addr, exists siz : nat,
      (star (MBlk ((getValinR s hp) + 2) lnk siz) (star (pto flist flistv) (
	star (MidL flistv (getValinR s prev) (getValinR s p)) (star (Stk TOP) arbh)))) s)
  (fun s : state => 
    fun s' : state => 
      POPS0S1S2 s s' /\ Gand ES0S1S2 ET0T1T2 s s' /\ RESRqd s s' /\ HIntact TOP 
      (getValinR s fp) s s' /\ forall others : assert, RfInsA others  ->
	(exists flistv : addr, exists lnk : addr, exists siz : nat, 	
	  (star (MBlk ((getValinR s hp) + 2) lnk siz) (star (pto flist flistv) (star 
	    (MidL flistv (getValinR s prev) (getValinR s p)) (star (Stk TOP) others)))) s) ->
	(exists flistv : addr, (star (pto flist flistv) (star (Good flistv) (
	  star (Stk TOP) others))) s')).
(** P S -> P' nextS **)
unfold FREE_FRAME. intros. induction s as [h rf]. inversion H0. simplRf'; simplRf H.
intuition. splitex. exists x; exists x0; exists x1. repeat (intros; rfinsen).
(** P S -> G' nextS S -> G S S' **)
intros. free_unall H1. induction s as [h rf]. induction s'' as [h'' rf'']. inversion H0.
rewrite <- H2 in H1. simplRf'; simplRf H1. intuition. clear H27. apply H22; auto.
splitex. exists x; exists x0; exists x1. repeat (intros; rfinsen). intros.
unfold RfInsA in H32. apply H32 with rf; auto.
(** bne p t1 L_free_notjhi **)
apply WF_bne with P_free_notjhi
  (fun s : state => getValinR s ra <> 0 /\ 
    FREE_FRAME s /\ getValinR s prev < getValinR s hp /\ getValinR s p <> pnil /\
    getValinR s hp < getValinR s p /\ getValinR s t0 = getVinH s ((getValinR s hp) + 1)/\
    exists flistv : addr, exists lnk : addr, exists siz : nat,
      (star (MBlk ((getValinR s hp) + 2) lnk siz) (star (pto flist flistv) (
	star (MidL flistv (getValinR s prev) (getValinR s p)) (star (Stk TOP) arbh)))) s
      /\ getValinR s p = getValinR s hp + siz)
  G_free_notjhi
  (fun s s' : state =>
      POPS0S1S2 s s' /\ Gand ES0S1S2 ET0T1T2 s s' /\ RESRqd s s' /\ HIntact TOP 
      (getValinR s fp) s s' /\ forall others : assert, RfInsA others  ->
	(exists flistv : addr, exists lnk : addr, exists siz : nat, 	
	  (star (MBlk ((getValinR s hp) + 2) lnk siz) (star (pto flist flistv) (star 
	    (MidL flistv (getValinR s prev) (getValinR s p)) (star (Stk TOP) others)))) s
	/\ getValinR s p = getValinR s hp + siz) ->
	(exists flistv : addr, (star (pto flist flistv) (star (Good flistv) (
	  star (Stk TOP) others))) s')).
(** psi (f) = theta *)
constructor. 
(** p <> t1 -> P => P' **) Focus 2.
unfold P_free_notjhi. unfold FREE_FRAME. intros. simplRf'; simplRf H.
intuition. rewrite H7 in H8. rewrite H8 in H0. splitex. exists x; exists x0;
exists x1. intuition. do 2 starassocr'. splitstar. unfold getVinH in H0; 
unfold getValinH in H0. hread2. readlh. clear H13. starrev H11. starassocr'. 
splitstar. clear H9. hread2. readlh.  clear H10. clear H12. clear H15. clear H11.
starrev H13. splitstar.  hread2. readlh. foldhread'. replace (hread' x6 (lookupR rf hp + 1)) 
with x1 in H0. assert (lookupR rf p >= lookupR rf hp + x1). mblkhinotoverlap. omega.
symmetry; mblkchunk. fauto. mblkindom. fauto. clear H10. clear H12. splitstar.
inrh. mblkindom. fauto. clear H10. clear H13. splitstar. inlh. splitstar. inlh. mblkindom.
(** p <> t1 -> P => G' => G **) Focus 2.
unfold G_free_notjhi. intros. intuition.  
(** p = t1 -> P => P'' **) Focus 2.
unfold FREE_FRAME. intros. simplRf H; simplRf'. intuition. splitex.
exists x; exists x0; exists x1. intuition. rewrite H0. rewrite H8. rewrite H7.
unfold getVinH; unfold getValinH. foldhread'. readsize. trivial. symmetry. 
splitstar. unfold hread'. hread2. readlh. foldhread'. mblkchunk. fauto. mblkindom. 
(** p = t1 -> P => G'' => G **) Focus 2.
intros. simplRf H. intuition. apply H10; auto. clear H13. splitex. exists x; exists x0;
exists x1. intuition.  simplRf'. rewrite H0. rewrite H11. rewrite H9. simplRf H13. 
unfold getVinH; unfold getValinH. foldhread'. readsize. trivial. symmetry.
splitstar. unfold hread'. hread2. readlh. foldhread'. mblkchunk. fauto. mblkindom.
(** lw t1 p size **)
apply WF_lw with 
  (fun s : state => getValinR s ra <> 0 /\ 
    FREE_FRAME s /\ getValinR s prev < getValinR s hp /\ getValinR s p <> pnil 
    /\ getValinR s hp < getValinR s p /\ getValinR s t0 = getVinH s ((getValinR s hp) + 1)
    /\ getValinR s t1 =  getVinH s (getValinR s p + 1) /\
    exists flistv : addr, exists lnk : addr, exists siz : nat,
      (star (MBlk ((getValinR s hp) + 2) lnk siz) (star (pto flist flistv) (
	star (MidL flistv (getValinR s prev) (getValinR s p)) (star (Stk TOP) arbh)))) s
      /\ getValinR s p = getValinR s hp + siz)
  (fun s s' : state =>POPS0S1S2 s s' /\ Gand ES0S1S2 ET0T1T2 s s' /\ RESRqd s s' /\ HIntact TOP 
    (getValinR s fp) s s' /\ forall others : assert, RfInsA others  ->
      (exists flistv : addr, exists lnk : addr, exists siz : nat, 	
	(star (MBlk ((getValinR s hp) + 2) lnk siz) (star (pto flist flistv) (star 
	  (MidL flistv (getValinR s prev) (getValinR s p)) (star (Stk TOP) others)))) s
      /\ getValinR s p = getValinR s hp + siz) ->
      (exists flistv : addr, (star (pto flist flistv) (star (Good flistv) (
	star (Stk TOP) others))) s')).
(** p + size in dom **)
intros. simplRf H. splitland. splitex. splitland. do 2 (splitstar; inrh). splitstar; inlh.
midlindom. 
(** P S -> P' nextS **)
unfold FREE_FRAME. intros. induction s as [h rf]. inversion H0. simplRf H; simplRf'.
intuition. unfold hread in H7; ungetVinH. rewrite H7; auto. splitex. exists x0; exists x1;
exists x2. intuition. repeat (intros; rfinsen). 
(** P S -> G' nextS S' -> G S S' **)
intros. induction s as [h rf]. induction s'' as [h'' rf'']. inversion H0. rewrite <- H3 in H1.
free_unall H1. simplRf H1; simplRf'. intuition. clear H24. apply H23; trivial. splitex.
exists x0; exists x1; exists x2. intuition.  repeat (intros; rfinsen). unfold RfInsA in H33.
intros; apply H33 with rf ; auto.
(** addu t1 t1 t0 **)
apply WF_addu with 
  (fun s : state =>getValinR s ra <> 0 /\ FREE_FRAME s /\ 
    getValinR s prev < getValinR s hp /\ getValinR s p <> pnil 
    /\ getValinR s hp < getValinR s p /\ getValinR s t1 =  
    getVinH s (getValinR s p + 1) + getVinH s ((getValinR s hp) + 1)/\
    exists flistv : addr, exists lnk : addr, exists siz : nat,
      (star (MBlk ((getValinR s hp) + 2) lnk siz) (star (pto flist flistv) (
	star (MidL flistv (getValinR s prev) (getValinR s p)) (star (Stk TOP) arbh)))) s
      /\ getValinR s p = getValinR s hp + siz)
  (fun s s' : state =>POPS0S1S2 s s' /\ Gand ES0S1S2 ET0T1T2 s s' /\ RESRqd s s' /\ HIntact TOP 
    (getValinR s fp) s s' /\ forall others : assert, RfInsA others  ->
      (exists flistv : addr, exists lnk : addr, exists siz : nat, 	
	(star (MBlk ((getValinR s hp) + 2) lnk siz) (star (pto flist flistv) (star 
	  (MidL flistv (getValinR s prev) (getValinR s p)) (star (Stk TOP) others)))) s
      /\ getValinR s p = getValinR s hp + siz) ->
      (exists flistv : addr, (star (pto flist flistv) (star (Good flistv) (
	star (Stk TOP) others))) s')).
(** P S -> P' nextS **)
unfold FREE_FRAME. intros. induction s as [h rf]. inversion H0. simplRf H; simplRf'.
intuition. splitex. exists x; exists x0; exists x1. intuition. repeat (intros; rfinsen).
(** P S -> G' nextS S' -> G S S' **)
intros. induction s as [h rf]. induction s'' as [h'' rf'']. inversion H0. rewrite <- H2 in H1.
free_unall H1. simplRf H1; simplRf H. intuition. clear H28. apply H22; trivial. splitex.
exists x; exists x0; exists x1. intuition. repeat (intros; rfinsen). unfold RfInsA in H33. 
intros;apply H33 with rf; auto.
(** sw hp size t1 **)
apply WF_sw with
  (fun s : state => getValinR s ra <> 0 /\ FREE_FRAME s /\ getValinR s prev < getValinR s hp
    /\ getValinR s p <> pnil /\ getValinR s hp < getValinR s p /\ 
    (getValinR s hp < getVinH s (getValinR s p) \/ getVinH s (getValinR s p) = pnil)
    /\ let (h, rf) := s in (hindom (lookupR rf p) h) /\ exists flistv : nat, exists lnk : nat, 
      exists lnk' : nat, exists siz : nat, exists n:nat, 
	star (MBlk (getValinR s hp + 2) lnk siz) (star (pto flist flistv) (star (EndL 
	  flistv (getValinR s prev) lnk') (star (MBlkLst n (getVinH s (getValinR s p)) pnil) 
	    (star(Stk TOP)arbh)))) s)
  (fun s s' : state => POPS0S1S2 s s' /\ Gand ES0S1S2 ET0T1T2 s s' /\ RESRqd s s' /\
    HIntact TOP (getValinR s fp) s s' /\ (forall others : assert, RfInsA others ->
      (exists flistv : nat, exists lnk : nat, exists lnk' : nat, exists siz : nat, 
	exists n : nat, star (MBlk (getValinR s hp + 2) lnk siz) (star (pto flist flistv)
	  (star (EndL flistv (getValinR s prev) lnk') (star (MBlkLst n (getVinH s (getValinR
	    s p)) pnil) (star (Stk TOP) others)))) s) ->
      (exists flistv : addr, (star (pto flist flistv) (star (Good flistv) (
	star (Stk TOP) others))) s'))).
(* hp + size in dom *)
intros. splitland. splitex. simplRf H4. splitland. splitstar. inlh. mblkindom.
(** P S -> P' nextS **)
unfold FREE_FRAME. intros. induction s as [h rf].  inversion H0. simplRf H; simplRf'.
intuition. splitex. splitland. unfold getVinH; unfold getValinH. unfold hwrite. 
unfold hread. simplneq. foldhread. starassocr H16. starrev H15. starassocl H16.
splitstar. hread2. readlh. foldhread'. assert (lookupR rf p < hread' x2 (lookupR rf p) 
\/ hread' x2 (lookupR rf p) = pnil). midlorder. inversion_clear H19. left; omega.
right; trivial. fauto. midlindom. starassocr H16. starassocr H15. splitstar. clear H20.
starrev H18. starassocr H19. splitstar. splitstar. apply beq_neq_false.
apply disj_indom_neq with x7 x6. fauto. mblkindom. midlindom. writeindom. 
splitex. inversion_clear H15. splitstar. inrh. splitstar. inrh. splitstar. inlh. midlindom.
(***** First Big Chanllege MergeHi: MBlk + MidL --> MBlk + EndL + MBlkLst***********)
splitex. exists x; exists x0; exists (lookupR rf p); exists (lookupR rf t1).
inversion_clear H15. rewrite H14. unfold getVinH.  unfold getValinH. repeat foldhread'. 
unfold hread' at 3. unfold hread; unfold hwrite at 1. simplneq. foldhread. foldhread'. 
starassocr H16. starassocr H15. splitstar. move H18 after H20.
starrev H18. starassocr H19. unfold hread'. hread2. readlh. hread2. readlh.
hread2. readlh. splitstar. hread2. readlh. hread2. readlh. hread2. readlh. splitstar.
hread2. readlh. hread2. readrh. hread2. readlh. unfold MidL in H24. splitex.
repeat foldhread'. exists (x8 - 1). do 3 assocrgoal. swpartlh x2 x3. inlh. inrh.
mblkindom. assoclgoal. starrev'. assocrgoal. swpartlh x4 x5. inrh. mblkindom. 
apply MergHi with x1; auto. fauto. midlindom. mblkindom. fauto. midlindom. fauto.
splitstar. inlh. midlindom. fauto. splitstar. inrh. mblkindom. fauto. splitstar.
inlh. midlindom.  fauto. splitstar. inlh. splitstar. inlh. midlindom. fauto. 
splitstar. inlh. splitstar. inrh. mblkindom. fauto. splitstar. inlh. splitstar.
inlh. midlindom. apply beq_nat_neq. starassocr H16. starassocr H15. splitstar.
move H18 after H20. starrev H18. starassocr H19. splitstar. starrev H21. splitstar.
apply disj_indom_neq with x6 x7; auto. mblkindom. midlindom. 
(** P S -> G' nextS S' -> G S S'**)
unfold FREE_FRAME. intros. induction s as [h rf]. induction s'' as [h'' rf''].
free_unall H1. inversion H0. rewrite <- H3 in H1. simplRf'; simplRf H1; simplRf H. 
splitland. splitex. inversion_clear H35. starrev H34. starassocl H35. splitstar.
starassocl H40. splitstar. starrev H43. starassocr H42. splitstar. splitstar. 
intuition. rewrite H25. ungetVinH. simplneq. apply beq_nat_neq. 
apply disj_indom_neq with x8 x9; auto. mblkindom. stkindom. rewrite H9. ungetVinH.
simplneq. apply beq_nat_neq. apply disj_indom_neq with x8 x9; auto. mblkindom. stkindom.
rewrite H28. ungetVinH. simplneq. apply beq_nat_neq. apply disj_indom_neq with x8 x9; auto. 
mblkindom. stkindom. rewrite H12. ungetVinH. simplneq. apply beq_nat_neq. 
apply disj_indom_neq with x8 x9; auto. mblkindom. stkindom. hintact'. notinstk.
mblkindom. fromnotinstk. inversion_clear H50. left;omega. right; auto. clalldisj.
clallheq. clallha. clallh. clear H37. clear x; clear x0; clear x1. splitex. 
inversion_clear H34. apply H13; auto.
(** Same chanllege MergeHi : MBlk + MidL -> MBlk + EndL + MBlkLst: More concise***)
exists x; exists x0; exists (lookupR rf p); exists (lookupR rf t1).
rewrite H32. unfold getVinH. unfold getValinH. starassocr H35. starassocr H34.
splitstar. move H38 after H40. starrev H38. starassocr H39. splitstar.
splitstar. assert (hindom (lookupR rf p) x6). midlindom. 
assert (hindom (lookupR rf p + 1) x6). midlindom. unfold MidL in H44. 
splitex. exists (x8 - 1). unfold hwrite at 1. unfold hread at 3. simplneq. 
foldhread. hread2; [readlh]. hread2; [readlh]. hread2; readlh. hread2; [readlh].
hread2; readlh. hread2; readrh. hread2; [readlh]. hread2; [readlh]. hread2; [readlh].
repeat foldhread'. do 3 assocrgoal. swpartlh x2 x3. inlh. inrh. mblkindom.
assoclgoal. starrev'. assocrgoal. swpartlh x4 x5. inrh. mblkindom.
apply MergHi with x1; auto. fauto. fauto. fauto. fauto. fauto. apply InDomC with x6 x7; auto.
fauto. inlh. apply InDomC with x6 x7; auto. mblkindom. fauto. inrh. mblkindom. fauto.
inlh. inrh. mblkindom. fauto. fauto. apply InDomC with x6 x7; auto. fauto. inlh. 
apply InDomC with x6 x7; auto. apply beq_nat_neq. 
assert (lookupR rf p <> lookupR rf hp + 1). apply disj_indom_neq with x6 x7; auto. 
mblkindom. auto.
(*** lw t0 p next **)
apply WF_lw with
  (fun s : state => getValinR s ra <> 0 /\ FREE_FRAME s /\ getValinR s prev < getValinR s hp 
    /\ getValinR s p <> pnil /\ getValinR s hp < getValinR s p /\ 
    (getValinR s hp < getVinH s (getValinR s p) \/ getVinH s (getValinR s p) = pnil) /\
    getValinR s t0 = getVinH s (getValinR s p) /\ exists flistv : nat, exists lnk : nat, 
      exists lnk' : nat, exists siz : nat, exists n:nat, 
	star (MBlk (getValinR s hp + 2) lnk siz) (star (pto flist flistv) (star (EndL 
	  flistv (getValinR s prev) lnk') (star (MBlkLst n (getVinH s (getValinR s p)) pnil) 
	    (star(Stk TOP)arbh)))) s)
  (fun s s' : state => POPS0S1S2 s s' /\ Gand ES0S1S2 ET0T1T2 s s' /\ RESRqd s s' /\
    HIntact TOP (getValinR s fp) s s' /\ (forall others : assert, RfInsA others ->
      (exists flistv : nat, exists lnk : nat, exists lnk' : nat, exists siz : nat, 
	exists n : nat, star (MBlk (getValinR s hp + 2) lnk siz) (star (pto flist flistv)
	  (star (EndL flistv (getValinR s prev) lnk') (star (MBlkLst n (getVinH s (getValinR
	    s p)) pnil) (star (Stk TOP) others)))) s) ->
      (exists flistv : addr, (star (pto flist flistv) (star (Good flistv) (
	star (Stk TOP) others))) s'))).
(** p in dom **)
intros. simpl0p. intuition. 
(** P S -> P' nextS **)
unfold FREE_FRAME. intros. induction s as [h rf]. inversion H0. simplRf'; simplRf'.
splitland; getland. ungetVinH. unfold hread in H7. simpl0p'. rewrite H7. trivial.
splitex. exists x0; exists x1; exists x2; exists x3; exists x4. repeat (intros; rfinsen).
(** P S -> G' nextS S -> G S S' **)
intros. free_unall H1. induction s as [h rf]. induction s'' as [h'' rf''].
inversion H0. rewrite <- H3 in H1. simplRf'; simplRf H1. splitland; getland.
intros. clear H35. apply H13; auto. splitex. exists x0; exists x1; exists x2;
exists x3; exists x4. unfold RfInsA in H34. repeat (intros; rfinsen). 
intros. apply H34 with rf; auto.
(** sw hp 0 t0 **)
apply WF_sw with
  (fun s : state => getValinR s ra <> 0 /\ FREE_FRAME s /\ getValinR s prev < getValinR s hp 
    /\ exists flistv : addr, exists lnk : addr, exists n : nat,
      (star (MBlkLst (S n) (getValinR s hp) pnil) (star (pto flist flistv) (
	star (EndL flistv (getValinR s prev) lnk) (star (Stk TOP) arbh)))) s)
  (fun s s' : state => POPS0S1S2 s s' /\ Gand ES0S1S2 ET0T1T2 s s' /\ RESRqd s s' /\ 
    HIntact TOP (getValinR s fp) s s' /\ forall others : assert, RfInsA others ->
      (exists flistv : addr, exists lnk : addr, exists n : nat, 	
	(star (MBlkLst (S n) (getValinR s hp) pnil) (star (pto flist flistv) (
	  star (EndL flistv (getValinR s prev) lnk) (star (Stk TOP) others)))) s) ->
      (exists flistv : addr, (star (pto flist flistv) (star (Good flistv) 
	(star (Stk TOP) others))) s')).
(** hp -> next indom **)
intros. splitland. splitex. simpl0p. splitstar. inlh. mblkindom. 
(** P S -> P' nextS **)
unfold FREE_FRAME. intros. induction s as [h rf]. inversion H0. simplRf'; simplRf H.
splitland. getland. rewrite H13. simpl0p. splitex. exists x; exists x1; exists x3.
do 3 starassocr'. do 2 assocrgoal. splitstar. writelh. clear H20. splitstar. inlh.
splitstar. inlh. splitstar. inlh. mblkindom. clear H20. starassocl H18. starrev H16.
starassocr H18. starrev'. assocrgoal. splitstar. writelh. splitstar. inrh. mblkindom.
starassocl H19. splitstar. writerh. splitstar. inrh. mblkindom. starrev H23. splitstar.
cblkblklst.
(** P S -> G' nextS S -> G S S' **)
unfold FREE_FRAME. intros. free_unall H1. induction s as [h rf]. induction s'' as [h'' rf''].
inversion H0. rewrite <- H3 in H1. simplRf'; simplRf H1; simplRf H. splitland. splitex. 
starrev H36. starassocl H35. splitstar. starassocl H40. splitstar. starassocl H43. 
splitstar. starrev H46.
starassocr H45. splitstar. splitstar. getland. rewrite H25. ungetVinH. simplneq. 
apply beq_neq_false. apply disj_indom_neq with x12 x13; auto. simpl0p; mblkindom.
stkindom. rewrite H9. ungetVinH. simplneq. apply beq_neq_false. apply disj_indom_neq 
with x12 x13; auto. simpl0p; mblkindom. stkindom. rewrite H28. ungetVinH. simplneq.
apply beq_neq_false. apply disj_indom_neq with x12 x13; auto. simpl0p; mblkindom. stkindom.
rewrite H12. ungetVinH. simplneq. apply beq_neq_false. apply disj_indom_neq with x12 x13; 
auto. simpl0p; mblkindom. stkindom. hintact'. simpl0p. notinstk. mblkindom. fromnotinstk.
inversion_clear H53. left; omega. right; assumption. clalldisj. clallheq. clallha. clallh.
intros. apply H13; auto. simpl0p. splitex. exists x4; exists x7; exists x10.
do 3 starassocr'. do 2 assocrgoal. splitstar. writelh. clear H42. splitstar. inlh.
splitstar. inlh. splitstar. inlh. mblkindom. clear H42. starassocl H39. starrev H38.
starassocr H39. starrev'. assocrgoal. splitstar. writelh. splitstar. inrh. mblkindom.
starassocl H40. splitstar. writerh. splitstar. inrh. mblkindom. starrev H46. splitstar.
cblkblklst. rewrite H33. assumption. rewrite H33; assumption.
(** j L_free_trylo **)
apply WF_j with P_free_trylo G_free_trylo. 
(** psi (f) = theta *)
unfold T_free_trylo. constructor; [constructor; assumption | auto].
(** P => P' **)
unfold P_free_trylo. unfold FREE_FRAME. intros. intuition.
(** P => G' => G **)
unfold G_free_trylo. intros. unfold RESRqd. intuition.
Save.
(********************************************************************)

Theorem WF_free_next :
  Infer (itpx2 (itpx1 T_free_next) psi_free_next) C_free_next.
Proof.
unfold C_free_next; unfold T_free_next; unfold psi_free_next.
unfold P_free_next; unfold G_free_next.
(** subu t0 p hp **)
apply WF_subu with
  (fun s : state => getValinR s ra <> 0 /\ FREE_FRAME s /\ getValinR s prev < getValinR s hp 
    /\ getValinR s p <> pnil /\ getValinR s t0 = getValinR s p - getValinR s hp /\
    exists flistv : addr, exists lnk : addr, exists siz : nat, (star 
      (MBlk ((getValinR s hp) + 2) lnk siz) (star (pto flist flistv) (star (MidL flistv 
	(getValinR s prev) (getValinR s p)) (star (Stk TOP) arbh)))) s)
  (fun s s' : state => POPS0S1S2 s s' /\ Gand ES0S1S2 ET0T1T2 s s' /\ RESRqd s s' /\
    HIntact TOP (getValinR s fp) s s' /\ forall others : assert, RfInsA others -> 
      (exists flistv : addr, exists lnk : addr, exists siz : nat, 
	(star (MBlk ((getValinR s hp) + 2) lnk siz) (
	    star (pto flist flistv) (star (MidL flistv (getValinR s prev) (getValinR s p)) (
	      star (Stk TOP) others)))) s) ->(exists flistv : addr, (star (pto flist flistv) (
		star (Good flistv) (star (Stk TOP) others))) s')).
(** P S ==> P nextS **)
intros. unfold FREE_FRAME. induction s as [h rf]. inversion H0. simplRf'. simplRf H.
intuition. splitex. exists x; exists x0; exists x1. repeat (intros; rfinsen).
(** P S -> G' nextS S' -> G S S' **)
intros. free_unall H1. inversion H0. rewrite <- H6 in H1. induction s'' as [h'' rf''].
 simplRf'; simplRf H1. intuition. clear H26. apply H21. unfold RfInsA; trivial. splitex.
exists x; exists x0; exists x1. repeat (intros; rfinsen). intros. apply H31 with rf; auto.
(** bgtz t0 L_free_tryhi **)
apply WF_bgtz with P_free_tryhi
  (fun s : state => getValinR s ra <> 0 /\  FREE_FRAME s /\ getValinR s prev < getValinR s hp 
    /\ getValinR s p <> pnil /\ getValinR s p < getValinR s hp /\
    exists flistv : addr, exists lnk : addr, exists siz : nat, (star 
      (MBlk ((getValinR s hp) + 2) lnk siz) (star (pto flist flistv) (star (MidL flistv 
	(getValinR s prev) (getValinR s p)) (star (Stk TOP) arbh)))) s)
  G_free_tryhi
  (fun s s' : state => POPS0S1S2 s s' /\ Gand ES0S1S2 ET0T1T2 s s' /\ RESRqd s s' /\
    HIntact TOP (getValinR s fp) s s' /\ forall others : assert, RfInsA others -> 
      (exists flistv : addr, exists lnk : addr, exists siz : nat, 
	(star (MBlk ((getValinR s hp) + 2) lnk siz) (
	  star (pto flist flistv) (star (MidL flistv (getValinR s prev) (getValinR s p)) (
	    star (Stk TOP) others)))) s) ->(exists flistv : addr, (star (pto flist flistv) (
	      star (Good flistv) (star (Stk TOP) others))) s')).
(** psi(f) = theta **)
constructor. 
(** gt 0 -> P ==> P' **) Focus 2.
unfold P_free_tryhi. intros. unfold FREE_FRAME; unfold FREE_FRAME in H.
simplRf'. simplRf H. splitland. rewrite H4 in H0. getland. omega. 
(** gt 0 -> P => G' => G **) Focus 2.
unfold G_free_tryhi. intros. intuition. 
(** le 0 -> P ==> P'' **) Focus 2.
intros.  simplRf'. simplRf H. splitland. rewrite H4 in H0.
assert (lookupR rf p <> lookupR rf hp). splitex. do 2 starassocr'. 
splitstar. clear H9. starrev H7. starassocr'. do 2 splitstar. 
apply disj_indom_neq with x6 x7; auto. midlindom. mblkindom. intuition. 
(** le 0 -> P ==> G'' ==> G **) Focus 2.
intros. intuition. 
(** addiu prev p 0 **)
apply WF_addiu with 
  (fun s : state =>getValinR s ra <> 0 /\  FREE_FRAME s /\ getValinR s prev < getValinR s hp 
    /\ getValinR s prev = getValinR s p /\ getValinR s p <> pnil /\ exists flistv : addr, 
      exists lnk : addr, exists siz : nat, (star (MBlk ((getValinR s hp) + 2) lnk siz) 
	(star (pto flist flistv) (star (MidL flistv (getValinR s prev) 
	  (getVinH s (getValinR s p))) (star (Stk TOP) arbh)))) s)
  (fun s s' : state => POPS0S1S2 s s' /\ Gand ES0S1S2 ET0T1T2 s s' /\ RESRqd s s' /\
    HIntact TOP (getValinR s fp) s s' /\ forall others : assert, RfInsA others -> 
      (exists flistv : addr, exists lnk : addr, exists siz : nat, 
	(star (MBlk ((getValinR s hp) + 2) lnk siz) ( star (pto flist flistv) 
	  (star (MidL flistv (getValinR s prev) (getVinH s (getValinR s p))) (
	    star (Stk TOP) others)))) s) ->(exists flistv : addr, (star (pto flist flistv) (
	      star (Good flistv) (star (Stk TOP) others))) s')).
(** P S -> P' nextS **)
unfold FREE_FRAME. intros. induction s as [h rf]. inversion H0. simplRf'. simplRf H. 
intuition. splitex. exists x; exists x0; exists x1. do 5 (intros; rfinsen). unfold 
getVinH. unfold getValinH. splitstar. hread2. readrh. getstar'. splitstar. hread2.
readrh. getstar'. splitstar. hread2. readlh. getstar'. simpl0p. foldhread'. movmidl.
fauto. midlindom. clear H14; clear H16. splitstar. inlh. midlindom. splitstar. inrh.
splitstar. clear H14. inlh. midlindom. 
(** P S -> G' nextS S' -> G S S' **)
intros. induction s as [h rf]. induction s'' as [h'' rf''].
free_unall H1. inversion H0. rewrite <- H2 in H1. simplRf'; simplRf H1. unfold getVinH;
unfold getVinH in H1. unfold getValinH; unfold getValinH in H1. intuition. clear H23.
apply H22; auto. splitex. exists x; exists x0; exists x1. do 4 (intros; rfinsen).
intros; rfinsen. intros. unfold RfInsA in H31. apply H31 with rf; auto.
splitstar. hread2. readrh. getstar'. splitstar. hread2. readrh. getstar'. 
splitstar. hread2. readlh. getstar'. simpl0p. foldhread'. movmidl.
fauto. midlindom. clear H33; clear H35. splitstar. inlh. midlindom. splitstar. inrh.
splitstar. clear H33. inlh. midlindom.
(** lw p p next **)
apply WF_lw with
  (fun s : state => getValinR s ra <> 0 /\ FREE_FRAME s /\ getValinR s prev < getValinR s hp
    /\  exists flistv : addr, exists lnk : addr, exists siz : nat, 
      (star (MBlk ((getValinR s hp) + 2) lnk siz) (star (pto flist flistv) (star (MidL flistv 
	(getValinR s prev) (getValinR s p)) (star (Stk TOP) arbh)))) s)
  (fun s s' : state => POPS0S1S2 s s' /\ Gand ES0S1S2 ET0T1T2 s s' /\ RESRqd s s' /\
    HIntact TOP (getValinR s fp) s s' /\ forall others : assert, RfInsA others -> 
      (exists flistv : addr, exists lnk : addr, exists siz : nat, 
	(star (MBlk ((getValinR s hp) + 2) lnk siz) ( star (pto flist flistv) 
	  (star (MidL flistv (getValinR s prev) (getValinR s p)) (
	    star (Stk TOP) others)))) s) ->(exists flistv : addr, (star (pto flist flistv) (
	      star (Good flistv) (star (Stk TOP) others))) s')).
(** p+0 in dom **)
intros. simplRf H. splitland. simpl0p. rewrite <- H2. splitex. do 2 (splitstar; inrh).
splitstar; inlh. midlindom0. omega. 
(** P S -> P' next S' **)
unfold FREE_FRAME. intros. induction s as [h rf]. inversion H0. simplRf'; simplRf H.
intuition. splitex. exists x0; exists x1; exists x2. unfold getVinH in H14.
unfold getValinH in H14. simpl0p'. rewrite H7 in H14. repeat (intros; rfinsen).
(** P S -> G' nextS S' -> G S S' **)
intros.  induction s as [h rf]. induction s'' as [h'' r'']. inversion H0.
rewrite <- H3 in H1. free_unall H1. simplRf H; simplRf H1; simplRf'. intuition.
clear H24. apply H23; auto. splitex. exists x0; exists x1; exists x2.  unfold getVinH in H24.
unfold getValinH in H24. simpl0p'. rewrite H8 in H24. repeat (intros; rfinsen).
unfold RfInsA in H32. intros. apply H32 with rf; auto. 
(** j L_free_iter **)
apply WF_j with P_free_iter G_free_iter. unfold T_free_iter.
constructor;[idtac | auto]. constructor.
(** P => P' **)
unfold P_free_iter. unfold FREE_FRAME. intros. intuition. 
(** P => G' => G **)
unfold G_free_iter. intros.  unfold RESRqd. intuition.
Save.

(************************************************************)
Theorem WF_free_iter :
  Infer (itpx2 (itpx1 T_free_iter) psi_free_iter) C_free_iter.
Proof.
unfold C_free_iter; unfold T_free_iter; unfold psi_free_iter.
unfold P_free_iter; unfold G_free_iter.
(** bgtz p L_free_next **)
apply WF_bgtz with P_free_next 
  (fun s : state => getValinR s ra <> 0 /\ getValinR s sp + 4 = getValinR s fp /\ 
    getValinR s fp > 4 /\ getValinR s fp < TOP /\ getValinR s prev < getValinR s hp /\ 
    getValinR s p = pnil /\ exists flistv : nat, exists lnk : nat, exists siz : nat, 
      star (MBlk (getValinR s hp + 2) lnk siz) (star (pto flist flistv) (star (MidL flistv 
	(getValinR s prev) pnil) (star (Stk TOP) arbh))) s) G_free_next
  (fun s s' : state => POPS0S1S2 s s' /\ Gand ES0S1S2 ET0T1T2 s s' /\ RESRqd s s' /\ 
    HIntact TOP (getValinR s fp) s s' /\ (forall oth : assert, RfInsA oth ->
      (exists flistv : addr, exists lnk : addr, exists siz : nat, star (MBlk (
	getValinR s hp + 2) lnk siz) (star (pto flist flistv) (star (MidL flistv 
	  (getValinR s prev) pnil) (star (Stk TOP) oth))) s) -> exists flistv : addr, 
      star (pto flist flistv) (star (Good flistv) (star (Stk TOP) oth)) s')).
(** Psi(f) = theta **)
constructor. 
(** gt 0 -> P => P' **) Focus 2.
intros. unfold P_free_next. simplRf'. simplRf H. intuition. 
(** gt 0 -> P => G' => G **) Focus 2.
intros. induction s' as [h' rf']. unfold G_free_next in H1. unfold POPS0S1S2 in H1; 
unfold POPS0S1S2. unfold ES0S1S2 in H1; unfold ES0S1S2. unGand H1. unRIntact H1. 
simplRf'. simplRf H1. intuition.
(** le 0 -> P => P'' **) Focus 2.
intros. simplRf'. simplRf H. inversion H0. rewrite H2.  rewrite H2 in H. intuition.
(** le 0 -> P => G'' => G **) Focus 2.
intros. clear H. unfold RESRqd in H1. intuition. apply H6. unfold RfInsA. trivial.
inversion H0. simplRf'. simplRf H8. rewrite H10. rewrite H10 in H8. trivial.
(** sw hp 0 p **)
apply WF_sw with 
  (fun s : state =>getValinR s ra <> 0 /\ getValinR s sp + 4 = getValinR s fp /\ 
    getValinR s fp > 4 /\ getValinR s fp < TOP /\ getValinR s prev < getValinR s hp /\ 
    exists flistv : nat, star (MBlkLst 1 (getValinR s hp) pnil) 
      (star (pto flist flistv) (star (EndL flistv 
	(getValinR s prev) pnil) (star (Stk TOP) arbh))) s)
  (fun s s' : state => POPS0S1S2 s s' /\ Gand ES0S1S2 ET0T1T2 s s' /\ RESRqd s s' /\ 
    HIntact TOP (getValinR s fp) s s' /\ (forall oth : assert, RfInsA oth ->
      (exists flistv : addr, star (MBlkLst 1 (getValinR s hp) pnil) (star (pto flist flistv)
	(star (EndL flistv (getValinR s prev) pnil) (star (Stk TOP) oth))) s) -> exists flistv 
      : addr, star (pto flist flistv) (star (Good flistv) (star (Stk TOP) oth)) s')).
(** indom hp+0 **)
intros. simplRf H. splitland. splitex. splitstar. inlh. mblkindom. 
(** P S ->  P nextS **)
intros. induction s as [h rf]. inversion H0. simplRf'. simplRf H. intuition. splitex.
exists x. splitstar. writelh. do 2 (splitstar; getstar'). fauto. mblkindom. rewrite H12.
mblkmblklst.
(** P S -> G' nextS -> G nextS **)
intros. induction s as [h rf]. inversion H0. rewrite <- H3 in H1. unfold POPS0S1S2;
unfold POPS0S1S2 in H1. unfold ES0S1S2; unfold ES0S1S2 in H1. unfold ET0T1T2; 
unfold ET0T1T2 in H1. unfold POPS0S1S2 in H1. unfold RESRqd; unfold RESRqd in H1. 
unGand H1. unRIntact H1. induction s'' as [h'' rf'']. simplRf'; simplRf H1. simplRf H.
splitland. splitex. do 3 starassocr'. splitstar. starrev H. do 2 (starassocr'; splitstar).
starrev H41. splitstar. intuition. rewrite H25. ungetVinH. simplneq.
 apply beq_neq_false. splitex. apply disj_indom_neq with x8 x9; auto. mblkindom. stkindom.
rewrite H9. ungetVinH. simplneq. apply beq_neq_false. splitex. apply disj_indom_neq with x8 x9;
auto. mblkindom. stkindom. rewrite H28. ungetVinH. simplneq. apply beq_neq_false. splitex.
apply disj_indom_neq with x8 x9; auto. mblkindom. stkindom. rewrite H12. ungetVinH. 
simplneq. apply beq_neq_false. splitex. apply disj_indom_neq with x8 x9; auto. mblkindom. 
stkindom. hintact'. notinstk. mblkindom. fromnotinstk. inversion_clear H47. left; omega.
right; trivial. apply H13; auto. splitex. exists x10. splitstar. writelh. 
do 2 (splitstar; getstar'). fauto. mblkindom. clear H51. rewrite H32. mblkmblklst.
(** j L_free_trylo **)
apply WF_j with P_free_trylo G_free_trylo.
(**Psi (f) = theta **)
constructor;[idtac|auto]. constructor.
(** P ==> P' **)
unfold P_free_trylo. intros. intuition. splitex. exists x. exists pnil; exists 0. trivial.
(** P ==> G' ==> G **)
intros. unfold G_free_trylo in H0. unfold RESRqd. intuition. apply H12. 
unfold RfInsA in H11. trivial. clear H10. splitex. exists x; exists pnil; exists 0. trivial.
Save.

(*** Well formedness of C_free_prolog **)
Theorem WF_free_entry :
  Infer (itpx2 (itpx1 T_free_entry) psi_free_entry) C_free_entry.
Proof.
unfold C_free_entry; unfold T_free_entry; unfold psi_free_entry.
unfold P_free_entry; unfold G_free_entry.
(** subiu hp free_ptr 2 **)
apply WF_subiu with 
  (fun s : state => getValinR s ra <> 0 /\ getValinR s sp + free_framesize = getValinR s fp
    /\ getValinR s fp > 4 /\ getValinR s fp < TOP /\ exists flistv : addr, 
      exists lnk : addr, exists siz : nat, (star (MBlk (getValinR s hp + 2) lnk siz) 
	(star (pto flist flistv) (star (Good flistv) (star (Stk TOP) arbh)))) s)
  (fun s : state => fun s' : state => Gand ES0S1S2 ET0T1T2 s s' /\ POPS0S1S2 s s' /\
      getValinR s' fp = getVinH s (getValinR s fp) /\ getValinR s' sp = getValinR s sp + 4 /\
      getValinR s' ra = getValinR s ra /\ HIntact TOP (getValinR s fp) s s'/\ 
      (forall others : assert, (forall (h : heap) (rf rf' : rfile), others (h, rf) -> 
	others (h, rf')) -> (exists flistv : addr, exists lnk : addr, exists siz : nat,
	  star (MBlk (getValinR s hp + 2) lnk siz) (star (pto flist flistv) (star (Good flistv) 
	    (star (Stk TOP) others))) s) -> exists flistv : addr, (star (pto flist flistv) 
	      (star (Good flistv) (star (Stk TOP) others))) s')).
(** P S --> P' nextS **)
intros. induction s as [h rf]. inversion H0. simplRf H; simplRf'. splitland. 
getland. splitex. exists x; exists x0; exists x1. simplps. repeat (intros; rfinsen).
apply plusex. splitstar. mblkup2.
(** P S --> G' nextS S' --> G S S'**)
intros. induction s as [h rf]. inversion H0. rewrite <- H2 in H1. unfold ES0S1S2;
unfold ES0S1S2 in H1. unfold ET0T1T2; unfold ET0T1T2 in H1. unfold POPS0S1S2 in H1.
unGand H1. unRIntact H1. induction s'' as [h'' rf'']. simplRf'; simplRf H1.
splitland; getland. clear H29. intros. apply H14; trivial. splitex. exists x; exists x0;
exists x1. simplps. repeat (intros; rfinsen). intros; apply H29 with rf; auto. apply plusex.
splitstar. mblkup2.
(** addiu prev zero 0 **)
apply WF_addiu with 
(fun s : state => getValinR s ra <> 0 /\ getValinR s sp + free_framesize = getValinR s fp 
  /\ getValinR s fp > 4 /\ getValinR s fp < TOP /\ getValinR s prev = pnil /\ 
  exists flistv : addr, exists lnk : addr, exists siz : nat, (star (MBlk (getValinR s hp + 2) 
    lnk siz) (star (pto flist flistv) (star (Good flistv) (star (Stk TOP) arbh)))) s)
  (fun s : state => fun s' : state => Gand ES0S1S2 ET0T1T2 s s' /\ POPS0S1S2 s s' /\
      getValinR s' fp = getVinH s (getValinR s fp) /\ getValinR s' sp = getValinR s sp + 4 /\
      getValinR s' ra = getValinR s ra /\ HIntact TOP (getValinR s fp) s s'/\ 
      (forall others : assert, (forall (h : heap) (rf rf' : rfile), others (h, rf) -> 
	others (h, rf')) -> (exists flistv : addr, exists lnk : addr, exists siz : nat,
	  star (MBlk (getValinR s hp + 2) lnk siz) (star (pto flist flistv) (star (Good flistv) 
	    (star (Stk TOP) others))) s) -> exists flistv : addr, (star (pto flist flistv) 
	      (star (Good flistv) (star (Stk TOP) others))) s')).
(** P S -> P' nextS **)
intros. induction s as [h rf]. inversion H0. simplRf H; simplRf'. splitland. 
getland. simplz. fauto. splitex. exists x; exists x0; exists x1. repeat (intros; rfinsen).
(** P S -> G' nextS S' -> G S S' **)
intros. induction s as [h rf]. inversion H0. rewrite <- H2 in H1. unfold ES0S1S2;
unfold ES0S1S2 in H1. unfold ET0T1T2; unfold ET0T1T2 in H1. unfold POPS0S1S2 in H1;
unfold POPS0S1S2. unGand H1. unRIntact H1. induction s'' as [h'' rf'']. simplRf'; simplRf H1.
splitland; getland. clear H31. intros. apply H14; trivial. splitex. exists x; exists x0;
exists x1. repeat (intros; rfinsen). intros; apply H30 with rf; auto.
(** lw p zero flist **)
apply WF_lw with
  (fun s : state => getValinR s ra <> 0 /\ getValinR s sp + free_framesize = getValinR s fp 
    /\ getValinR s fp > 4 /\ getValinR s fp < TOP /\ getValinR s prev = pnil /\ 
    getValinR s p = getVinH s flist/\ exists flistv : addr,  exists lnk : addr,
      exists siz : nat, (star (MBlk (getValinR s hp + 2) lnk siz) 
	(star (pto flist flistv) (star (Good flistv) (star (Stk TOP) arbh)))) s)
  (fun s : state => fun s' : state => Gand ES0S1S2 ET0T1T2 s s' /\ POPS0S1S2 s s' /\
      getValinR s' fp = getVinH s (getValinR s fp) /\ getValinR s' sp = getValinR s sp + 4 /\
      getValinR s' ra = getValinR s ra /\ HIntact TOP (getValinR s fp) s s'/\ 
      (forall others : assert, (forall (h : heap) (rf rf' : rfile), others (h, rf) -> 
	others (h, rf')) -> (exists flistv : addr, exists lnk : addr, exists siz : nat,
	  star (MBlk (getValinR s hp + 2) lnk siz) (star (pto flist flistv) (star (Good flistv) 
	    (star (Stk TOP) others))) s) -> exists flistv : addr, (star (pto flist flistv) 
	      (star (Good flistv) (star (Stk TOP) others))) s')).
(** flist in dom **)
intros. simplz. fauto. splitland. splitex. splitstar. inrh. splitstar. inlh.
simpl0p. ptoindom. fauto.
(** P S --> P' nextS **)
intros. induction s as [h rf]. inversion H0. simplRf H; simplRf'. splitland; getland.
unfold getVinH. unfold getValinH. simplz'. simpl0p'. rewrite H7; auto. splitex.
exists x0; exists x1; exists x2. repeat (intros; rfinsen). 
(** P S --> G' nextS S' --> G S S' **)
intros. induction s as [h rf]. inversion H0. rewrite <- H3 in H1. unfold ES0S1S2;
unfold ES0S1S2 in H1. unfold ET0T1T2; unfold ET0T1T2 in H1. unfold POPS0S1S2 in H1;
unfold POPS0S1S2. unGand H1. unRIntact H1. induction s'' as [h'' rf'']. simplRf'; simplRf H1.
splitland; getland. clear H33. intros. apply H15; trivial. splitex. exists x0; exists x1;
exists x2. repeat (intros; rfinsen). intros; apply H32 with rf; auto.
(** j L_free_iter **)
apply WF_j with P_free_iter G_free_iter.
(*in psi*)
constructor.
(* P S --> P' S**)
intros. unfold P_free_iter. induction s as [h rf]. simplRf'. simplRf H.
splitland; getland. splitex. splitstar. rewrite H3. assert (lookupR rf hp + 2 > 2).
mblkup2. omega. splitex. exists x; exists x0; exists x1. rewrite H3; rewrite H4.
unfold getVinH. unfold getValinH. ptoread. do 3 (splitstar; getstar'). fauto. 
splitstar. hread2. readrh. splitstar. hread2. readlh. apply ptoHRead with rf; auto.
apply disj_sym; auto. ptoindom. clear H6. splitstar. inlh. ptoindom. 
(** P S --> G' S S' -> G S S' **) 
unfold G_free_iter; intros. induction s as [h rf]. intuition.
apply H13; trivial. clear H12. splitex. exists x; exists x0; exists x1.
rewrite H7; rewrite H9. unfold getVinH. unfold getValinH. ptoread.
do 3 (splitstar; getstar').  fauto. splitstar. hread2. readrh. splitstar. hread2.
readlh. apply ptoHRead with rf; auto. fauto. ptoindom. clear H14. splitstar.
inlh. ptoindom. 
Save.
(***********************************************************************)
Theorem WF_free_prolog : 
  Infer (itpx2 (itpx1 T_free_prolog) psi_free_prolog) C_free_prolog.
Proof. unfold C_free_prolog.
(* subiu sp sp free_framesize *)
unfold T_free_prolog. apply WF_subiu with 
(fun s : state => getValinR s ra <> 0 /\ (getValinR s fp < TOP) /\ 
  (getValinR s sp + 4 < getValinR s fp) /\ (getValinR s sp > 1) /\ 
  exists flistv : addr,exists lnk : addr, exists siz : nat,
    (star (MBlk (getValinR s free_ptr) lnk siz) (star (pto flist flistv) (
      star (Good flistv) (star (Stk TOP) arbh)))) s)
(fun s : state => fun s' : state => (Gand S0S1S2 ET0T1T2) s s'/\
  getValinR s' sp = getValinR s sp + free_framesize /\
  getValinR s' fp = getValinR s fp /\ getValinR s' ra = getValinR s ra /\
  HIntact TOP (getValinR s sp + free_framesize) s s' /\
  (forall others : assert,(forall (h : heap) (rf rf' : rfile), 
    others (h, rf) -> others (h, rf')) ->
  (exists flistv : addr, exists lnk : addr, exists siz : nat,
    star (MBlk (getValinR s free_ptr) lnk siz) (star (pto flist flistv) (
      star (Good flistv) (star (Stk TOP) others))) s)->
  exists flistv : addr,(star (pto flist flistv) (star (Good flistv) (
    star (Stk TOP) others))) s')).
(*P ==> P'*)
intros. induction s as [h rf]. inversion H0. unfold P_free_prolog in H. 
unfold getValinR. simplRf H. simplRf'. intuition. splitex. exists x; exists x0;
exists x1. repeat (intros; rfinsen).
(*P S -> G' nextS S' -> G S S'*)
intros. induction s as [h rf]. unfold G_free_prolog. unfold P_free_prolog in H.
unfold S0S1S2; unfold S0S1S2 in H1.  unfold ET0T1T2; unfold ET0T1T2 in H1. 
unfold Rqd; unfold Rqd in H1. unGand H1. unRIntact H1. inversion H0. 
rewrite <- H2 in H1. induction s'' as [h'' rf'']. simplRf'. simplRf H1. simplRf H. 
splitland; getland. rewrite H1. apply plusex. omega. unHIntact H11. ungetValinH H11.
intros. apply H11. replace (lookupR rf sp - 4 + 4) with (lookupR rf sp).
auto. apply plusex. omega. intros. apply H13. auto. clear H29. splitex. 
exists x; exists x0; exists x1. repeat (intros; rfinsen). intros. apply H30 with rf. auto.
(** sw sp 4 fp **)
apply WF_sw with 
  (fun s : state => getValinR s ra <> 0 /\ (getValinR s fp < TOP) /\ 
    (getValinR s sp + 4 < getValinR s fp) /\ (getValinR s sp > 1) /\ 
    exists flistv : addr,exists lnk : addr, exists siz : nat,
      (star (MBlk (getValinR s free_ptr) lnk siz) (star (pto flist flistv) (
        star (Good flistv) (star (Stk TOP) arbh)))) s)
  (fun s : state => fun s' : state => (Gand S0S1S2 ET0T1T2) s s'/\
    getValinR s' sp = getValinR s sp + free_framesize /\ getValinR s' ra = getValinR s ra /\
    getValinR s' fp = getVinH s (getValinR s sp + 4) /\ 
    HIntact TOP (getValinR s sp + free_framesize) s s' /\
    (forall others : assert,(forall (h : heap) (rf rf' : rfile), 
      others (h, rf) -> others (h, rf')) ->
    (exists flistv : addr, exists lnk : addr, exists siz : nat,
      star (MBlk (getValinR s free_ptr) lnk siz) (star (pto flist flistv) (
	star (Good flistv) (star (Stk TOP) others))) s)->
    exists flistv : addr,(star (pto flist flistv) (star (Good flistv) (
      star (Stk TOP) others))) s')). 
(** indom sp+4 h **)
intros. simplRf H. splitland. splitex. do 3 (splitstar; inrh) . splitstar; inlh. 
apply StkInDom with TOP rf. auto. getland. assert (lookupR rf sp + 4 < TOP). 
omega. omega. omega. 
(** P ==> P' **)
intros. induction s as [h rf]. inversion H0. simplRf H. simplRf'. 
splitland. getland. splitex. exists x; exists x0; exists x1. 
assert (lookupR rf sp + 4 < TOP). omega. splitstar. writerh.
 do 2 (splitstar; inrh). splitstar; inlh. stkindom. splitstar. writerh. 
splitstar; inrh. splitstar; inlh. stkindom. splitstar. writerh. splitstar; inlh. stkindom.
splitstar. writelh. stkindom. apply StkRet; auto. stkindom. 
(**P S -> G' nextS S' -> G S S' **)
intros. induction s as [h rf]. inversion H0. rewrite <- H3 in H1. 
unfold S0S1S2; unfold S0S1S2 in H1. unfold ET0T1T2; unfold ET0T1T2 in H1.
unGand H1. unRIntact H1. induction s'' as [h'' rf'']. simplRf'; simplRf H1; simplRf H.
splitland. getland. rewrite H11. simplHp. simpleq. apply beq_eq_true; auto.
hintact (lookupR rf sp + 4) (lookupR rf fp). intros. apply H14; auto. clear H32.
splitex. exists x; exists x0; exists x1. assert (lookupR rf sp + 4 < TOP). omega. 
splitstar. writerh. do 2 (splitstar; inrh). splitstar; inlh. stkindom.
splitstar.  writerh. splitstar; inrh. splitstar; inlh. stkindom. splitstar. writerh. 
splitstar; inlh. stkindom. splitstar. writelh. stkindom. apply StkRet; auto. stkindom.
(*addiu fp sp 4 **)
apply WF_addiu with 
  (fun s : state => getValinR s ra <> 0 /\ getValinR s fp < TOP /\ 
    getValinR s sp + 4 = getValinR s fp /\ getValinR s sp > 1 /\ 
    exists flistv : addr, exists lnk : addr, exists siz : nat, 
      star (MBlk (getValinR s free_ptr) lnk siz) (star (pto flist flistv) (star (Good flistv)
	(star (Stk TOP) arbh))) s)
  (fun s s' : state => Gand S0S1S2 ET0T1T2 s s' /\ getValinR s' sp = getValinR s sp + 4 /\
    getValinR s' ra = getValinR s ra /\ getValinR s' fp = getVinH s (getValinR s fp) /\
    HIntact TOP (getValinR s fp) s s' /\ (forall (others : assert), (forall (h : heap)
      (rf rf' : rfile), others (h, rf) -> others (h, rf')) -> (exists flistv : addr, 
	exists lnk : nat, exists siz : nat, star (MBlk (getValinR s free_ptr) lnk siz)
          (star (pto flist flistv) (star (Good flistv) (star (Stk TOP) others))) s) ->
  exists flistv : nat,
    star (pto flist flistv)
    (star (Good flistv) (star (Stk TOP) others)) s')).
(* P ==> P' **)
intros. induction s as [h rf]. inversion H0. getvalinr H. simplRf'. splitland. 
getland. omega. splitex. exists x; exists x0; exists x1. repeat (intros; rfinsen).
(* P S -> G' nextS S' -> G S S'*)
intros. induction s as [h rf]. inversion H0. rewrite <- H2 in H1. 
unfold S0S1S2 in H1; unfold S0S1S2. unfold ET0T1T2 in H1; unfold ET0T1T2.
unGand H1. unRIntact H1. induction s'' as [h'' rf'']. simplRf H1. simplRf'.
splitland; getland. intros. apply H13. auto. clear H31. splitex. exists x; exists x0; 
exists x1. repeat (intros; rfinsen). intros. apply H30 with rf; auto.
(** sw_ fp 1 hp **)
apply WF_sw_ with 
  (fun s : state => getValinR s ra <> 0 /\ getValinR s fp < TOP /\ 
    getValinR s sp + 4 = getValinR s fp /\ getValinR s sp > 1 /\ 
    exists flistv : addr, exists lnk : addr, exists siz : nat, 
      star (MBlk (getValinR s free_ptr) lnk siz) (star (pto flist flistv) (star (Good flistv)
	(star (Stk TOP) arbh))) s)
  (fun s s' : state => Gand ES0 ET0T1T2 s s' /\ getValinR s' sp = getValinR s sp + 4 /\
    getValinR s' ra = getValinR s ra /\ getValinR s' fp = getVinH s (getValinR s fp) /\
    getValinR s' hp = getVinH s (getValinR s fp - 1) /\ HIntact TOP (getValinR s fp) s s' 
    /\ (forall (others : assert), (forall (h : heap) (rf rf' : rfile), 
      others (h, rf) -> others (h, rf')) -> (exists flistv : addr, 
	exists lnk : nat, exists siz : nat, star (MBlk (getValinR s free_ptr) lnk siz)
          (star (pto flist flistv) (star (Good flistv) (star (Stk TOP) others))) s) ->
      exists flistv : nat,star (pto flist flistv) 
	(star (Good flistv) (star (Stk TOP) others)) s')).
(** hindom fp-1 h **)
intros. simplRf H. splitland. rewrite <- H1. splitex. 
do 3 (splitstar; inrh) . splitstar; inlh. stkindom.
(** P S --> P' nextS**)
intros. induction s as [h rf]. inversion H0. simplRf H. simplRf'. 
splitland. getland. splitex. exists x; exists x0; exists x1. 
splitstar. writerh. do 2 (splitstar; inrh). splitstar; inlh. stkindom. splitstar. writerh. 
splitstar; inrh. splitstar; inlh. stkindom. splitstar. writerh. splitstar; inlh. stkindom.
splitstar. writelh. stkindom. apply StkRet; auto. stkindom. 
(** P S --> G' nextS S''--> G S S''**)
intros. induction s as [h rf]. inversion H0. rewrite <- H3 in H1. 
unfold S0S1S2; unfold ES0 in H1. unfold ET0T1T2; unfold ET0T1T2 in H1.
unGand H1. unRIntact H1. induction s'' as [h'' rf'']. simplRf'; simplRf H1; simplRf H.
splitland. getland. rewrite H12. simplHp. simpleq. apply beq_eq_true; auto.
rewrite H11. simplHp. simplneq. apply beq_neq_false; omega.
hintact (lookupR rf fp - 1) (lookupR rf hp). rewrite <- H29; auto. omega.
intros. apply H15; auto. clear H32. splitex. exists x; exists x0; exists x1. 
splitstar. writerh. do 2 (splitstar; inrh). splitstar; inlh. stkindom.
splitstar.  writerh. splitstar; inrh. splitstar; inlh. stkindom. splitstar. writerh. 
splitstar; inlh. stkindom. splitstar. writelh. stkindom. apply StkRet; auto. stkindom.
(* sw_ fp 2 prev *)
apply WF_sw_ with 
  (fun s : state => getValinR s ra <> 0 /\ getValinR s fp < TOP /\ 
    getValinR s sp + 4 = getValinR s fp /\ getValinR s sp > 1 /\ 
    exists flistv : addr, exists lnk : addr, exists siz : nat, 
      star (MBlk (getValinR s free_ptr) lnk siz) (star (pto flist flistv) (star (Good flistv)
	(star (Stk TOP) arbh))) s)
  (fun s s' : state => Gand ES0S1 ET0T1T2 s s' /\ getValinR s' sp = getValinR s sp + 4 /\
    getValinR s' ra = getValinR s ra /\ getValinR s' fp = getVinH s (getValinR s fp) /\
    getValinR s' hp = getVinH s (getValinR s fp - 1) /\ HIntact TOP (getValinR s fp) s s' /\
    getValinR s' prev = getVinH s (getValinR s fp - 2) /\ (forall (others : assert), 
      (forall (h : heap) (rf rf' : rfile), 
	others (h, rf) -> others (h, rf')) -> (exists flistv : addr, 
	exists lnk : nat, exists siz : nat, star (MBlk (getValinR s free_ptr) lnk siz)
          (star (pto flist flistv) (star (Good flistv) (star (Stk TOP) others))) s) ->
      exists flistv : nat,star (pto flist flistv) 
	(star (Good flistv) (star (Stk TOP) others)) s')).
(** hindom fp-1 h **)
intros. simplRf H. splitland. rewrite <- H1. splitex. 
do 3 (splitstar; inrh) . splitstar; inlh. stkindom.
(** P S --> P' nextS**)
intros. induction s as [h rf]. inversion H0. simplRf H. simplRf'. 
splitland. getland. splitex. exists x; exists x0; exists x1. 
splitstar. writerh. do 2 (splitstar; inrh). splitstar; inlh. stkindom. splitstar. writerh. 
splitstar; inrh. splitstar; inlh. stkindom. splitstar. writerh. splitstar; inlh. stkindom.
splitstar. writelh. stkindom. apply StkRet; auto. stkindom. 
(** P S --> G' nextS S''--> G S S''**)
intros. induction s as [h rf]. inversion H0. rewrite <- H3 in H1. 
unfold ES0; unfold ES0S1 in H1. unfold ET0T1T2; unfold ET0T1T2 in H1.
unGand H1. unRIntact H1. induction s'' as [h'' rf'']. simplRf'; simplRf H1; simplRf H.
splitland. getland. rewrite H14. simplHp. simpleq. apply beq_eq_true; auto.
rewrite H11. simplHp. simplneq. apply beq_neq_false; omega. rewrite H12.
simplHp. simplneq. apply beq_neq_false; omega. hintact (lookupR rf fp - 2) (lookupR rf prev). 
rewrite <- H29; auto. omega. intros. apply H16; auto. clear H32. splitex. 
exists x; exists x0; exists x1. splitstar. writerh. do 2 (splitstar; inrh). splitstar; inlh. 
stkindom. splitstar.  writerh. splitstar; inrh. splitstar; inlh. stkindom. splitstar. writerh. 
splitstar; inlh. stkindom. splitstar. writelh. stkindom. apply StkRet; auto. stkindom.
(* sw_ fp 3 p *)
apply WF_sw_ with 
  (fun s : state => getValinR s ra <> 0 /\ getValinR s fp < TOP /\ 
    getValinR s sp + 4 = getValinR s fp /\ getValinR s sp > 1 /\ 
    exists flistv : addr, exists lnk : addr, exists siz : nat, 
      star (MBlk (getValinR s free_ptr) lnk siz) (star (pto flist flistv) (star (Good flistv)
	(star (Stk TOP) arbh))) s)
  (fun s s' : state => Gand ES0S1S2 ET0T1T2 s s' /\ getValinR s' sp = getValinR s sp + 4 /\
    getValinR s' ra = getValinR s ra /\ getValinR s' fp = getVinH s (getValinR s fp) /\
    getValinR s' hp = getVinH s (getValinR s fp - 1) /\ HIntact TOP (getValinR s fp) s s' /\
    getValinR s' prev = getVinH s (getValinR s fp - 2) /\ 
    getValinR s' p = getVinH s (getValinR s fp - 3) /\ (forall (others : assert), 
      (forall (h : heap) (rf rf' : rfile), 
	others (h, rf) -> others (h, rf')) -> (exists flistv : addr, 
	exists lnk : nat, exists siz : nat, star (MBlk (getValinR s free_ptr) lnk siz)
          (star (pto flist flistv) (star (Good flistv) (star (Stk TOP) others))) s) ->
      exists flistv : nat,star (pto flist flistv) 
	(star (Good flistv) (star (Stk TOP) others)) s')).
(** hindom fp-2 h **)
intros. simplRf H. splitland. rewrite <- H1. splitex. 
do 3 (splitstar; inrh) . splitstar; inlh. stkindom.
(** P S --> P' nextS**)
intros. induction s as [h rf]. inversion H0. simplRf H. simplRf'. 
splitland. getland. splitex. exists x; exists x0; exists x1. 
splitstar. writerh. do 2 (splitstar; inrh). splitstar; inlh. stkindom. splitstar. writerh. 
splitstar; inrh. splitstar; inlh. stkindom. splitstar. writerh. splitstar; inlh. stkindom.
splitstar. writelh. stkindom. apply StkRet; auto. stkindom. 
(** P S --> G' nextS S''--> G S S''**)
intros. induction s as [h rf]. inversion H0. rewrite <- H3 in H1. 
unfold ES0S1; unfold ES0S1S2 in H1. unfold ET0T1T2; unfold ET0T1T2 in H1.
unGand H1. unRIntact H1. induction s'' as [h'' rf'']. simplRf'; simplRf H1; simplRf H.
splitland. getland. rewrite H15. simplHp. simpleq. apply beq_eq_true; auto.
rewrite H11. simplHp. simplneq. apply beq_neq_false; omega. rewrite H12. simplHp. simplneq. 
apply beq_neq_false; omega.  hintact (lookupR rf fp - 3) (lookupR rf p). 
rewrite <- H29; auto. omega. rewrite H14. simplHp. simplneq. apply beq_neq_false; omega.
intros. apply H17; auto. clear H32. splitex. exists x; exists x0; exists x1. splitstar. 
writerh. do 2 (splitstar; inrh). splitstar; inlh. stkindom. splitstar.  writerh. 
splitstar; inrh. splitstar; inlh. stkindom. splitstar. writerh. splitstar; inlh. 
stkindom. splitstar. writelh. stkindom. apply StkRet; auto. stkindom.
(** j L_free_entry **)
apply WF_j with P_free_entry G_free_entry.
(** L_free_entry in psi **)
unfold psi_free_prolog. repeat constructor. auto.
(** P S -> psi(f).P S **)
unfold P_free_entry. intros. induction s as [h rf]. simplRf H. simplRf'.
splitland. getland. omega. 
(** P S -> psi(f).G S S' -> G S S'**)
intros. induction s as [h rf]. unfold G_free_entry in H0. intuition.
Save.


(**The End**)


 


