(*** Lemma library from inference rules ***)
Require Import natutil.
Require Import heap2.
Require Import scap.
Require Import scap_rules.
Require Import Omega.



(** if Psi is subset of Psi', then **)

Lemma Infer_interp_strengthen :
  forall (a a' : interp) (is : iseq),
    (forall (psi : codeheapty) (s :state), a' psi s -> a psi s) ->
    Infer a is -> Infer a' is.
Proof.
intros.
induction is.
 induction i.
  inversion_clear H0.
    apply I_rest with a'0; intuition.
  inversion_clear H0.
    apply I_rest with a'0; intuition.
  inversion_clear H0.
    apply I_rest with a'0; intuition.
  inversion_clear H0.
    apply I_rest with a'0; intuition.
  inversion_clear H0.
   apply I_beq with a'0; intros; auto.
   apply I_beq with a'0; intros; auto.
     elim H1 with psi (h, rf); intros.
    inversion_clear H3; inversion_clear H4.
    apply H; auto.
  inversion_clear H0.
   apply I_bgez with a'0; intros; auto.
   apply I_bgez with a'0; intros; auto.
     elim H1 with psi (h, rf); intros.
    inversion_clear H3; inversion_clear H4.
    apply H; auto.
  inversion_clear H0.
   apply I_bgtz with a'0; intros; auto.
   apply I_bgtz with a'0; intros; auto.
     elim H1 with psi (h, rf); intros.
    inversion_clear H3; inversion_clear H4.
    apply H; auto.
  inversion_clear H0.
   apply I_blez with a'0; intros; auto.
   apply I_blez with a'0; intros; auto.
     elim H1 with psi (h, rf); intros.
    inversion_clear H3; inversion_clear H4.
    apply H; auto.
  inversion_clear H0.
   apply I_bltz with a'0; intros; auto.
   apply I_bltz with a'0; intros; auto.
     elim H1 with psi (h, rf); intros.
    inversion_clear H3; inversion_clear H4.
    apply H; auto.
  inversion_clear H0.
   apply I_bne with a'0; intros; auto.
   apply I_bne with a'0; intros; auto.
     elim H1 with psi (h, rf); intros.
    inversion_clear H3; inversion_clear H4.
    apply H; auto.
  inversion_clear H0.
    apply I_rest with a'0; intuition.
  inversion_clear H0.
    apply I_rest with a'0; intuition.
  inversion_clear H0.
    apply I_rest with a'0; intuition.
  inversion_clear H0.
    apply I_rest with a'0; intuition.
 inversion_clear H0.
   apply I_j; intuition.
 inversion_clear H0.
   apply I_jal; intuition.
 inversion_clear H0.
   apply I_jalr; intuition.
 inversion_clear H0.
   apply I_jr; intuition.
Save.


Lemma Infer_psi_strengthen :
  forall (psi psi' : codeheapty) (theta : codespec) (is : iseq),
    psi_subseteq psi psi' ->
    Infer (itpx2 (itpx1 theta) psi) is ->
    Infer (itpx2 (itpx1 theta) psi') is.
Proof.
intros.
apply Infer_interp_strengthen with (itpx2 (itpx1 theta) psi);intuition.
inversion_clear H1.
constructor;auto.
apply psi_subseteq_trans with psi';auto.
Save.




(** if f~~> theta in Psi , then forall superset Psi', f~~~> theta in Psi' too**)
Lemma psidom_insub_insup :
  forall (psi psi' : codeheapty) (f : lab) (theta : codespec),
    psi_subseteq psi psi' ->lookupCT psi f theta -> lookupCT psi' f theta.
Proof.
intros.
inversion_clear H.
apply H1.
assumption.
Save.

Lemma stack_strengthen :
  forall (n : nat) (p p' : assert) (psi : codeheapty),
    (forall (s : state), p' s -> p s) ->  WFST n p psi -> WFST n p' psi.
Proof.
induction n.
intros.
inversion_clear H0.
constructor.
intros.
assert (p (h, rf)).
apply H; assumption.
apply H1 with h; assumption.
inversion_clear H1.
intros.
inversion_clear H0.
constructor.
omega.
intros.
assert (p (h, rf)).
apply H; assumption.
apply H2; assumption.
Save.

(** jal lemma ***)
Lemma WF_jal : 
  forall (psi : codeheapty) (p p' p'' : assert) (g g' g'' : action)
    (f fret : lab), 
    lookupCT psi f (cdspec p' g') ->
    lookupCT psi fret (cdspec p'' g'') ->
    (forall (h : heap) (rf : rfile), p (h, rf) -> p' (h, updateR rf ra fret)) ->
    (forall (h : heap) (rf : rfile) (s' : state), p (h, rf) -> 
      g' (h, updateR rf ra fret) s' -> p'' s') ->
    (forall (h : heap) (rf : rfile) (s' : state) (s'' : state), p (h, rf) ->
      g' (h, updateR rf ra fret) s' -> g'' s' s'' -> g (h, rf) s'') ->
    (forall (h : heap) (rf : rfile) (h' : heap) (rf' : rfile), g' (h, rf) (h', rf') ->
      lookupR rf ra = lookupR rf' ra) ->
    Infer (itpx2 (itpx1 (cdspec p g) ) psi) (jal f fret).
Proof.
intros.
constructor.
intros.
unfold itpx2 in H5.
inversion_clear H5.
exists (cdspec p' g').
split.
apply psidom_insub_insup with psi; auto.
unfold itpx1; unfold itpx1 in H7.
inversion_clear H7.
split.
apply H1; auto.
inversion_clear H8.
exists (x + 1).
constructor.
omega.
intros.
exists p''; exists g''.
split.
assert (lookupR (updateR rf ra fret) ra = lookupR rf0 ra).
apply H4 with h h0; trivial.
rewrite <- H9.
replace (lookupR (updateR rf ra fret) ra) with fret.
apply psidom_insub_insup with psi; assumption.
unfold updateR.
unfold lookupR.
replace (beq_reg ra ra) with true.
trivial.
unfold beq_reg; trivial.
replace (x + 1 -1) with x.
split.
apply H2 with h rf; auto.
apply stack_strengthen with (g (h, rf)).
intros.
apply H3 with (h0, rf0); auto.
assumption.
omega.
Save.

(** lemma jr ra : function returning****)
Lemma WF_jr_ra' :
  forall (p : assert) (g : action),
    (forall (h : heap) (rf : rfile), p (h, rf) ->
      g (h, rf) (h, rf) /\ lookupR rf ra <> 0) ->
    Infer (itpx2 (itpx1 (cdspec p g)) emptyCT) (jr ra).
Proof.
intros.
constructor.
intros.
unfold itpx1 in H0; unfold itpx2 in H0.
inversion_clear H0.
inversion_clear H2.
inversion_clear H3.
assert (g (h, rf) (h, rf) /\ lookupR rf ra <> 0).
apply H; auto.
inversion H2.
assert (lookupR rf ra = 0).
apply H4 with h; intuition.
inversion_clear H3. contradiction.
assert (exists p' : assert,
         (exists g' : action,
            lookupCT psi (lookupR rf ra) (cdspec p' g') /\
            p' (h, rf) /\ WFST (x - 1) (g' (h, rf)) psi)).
apply H5; auto.
intuition.
inversion_clear H9.
inversion_clear H10.
exists (cdspec x0 x1).
split.
intuition.
unfold itpx1.
split.
intuition.
exists (x - 1); intuition.
Save.


Lemma WF_jr_ra :
  forall (p : assert) (g : action),
    (forall (h : heap) (rf : rfile), p (h, rf) -> 
      g (h, rf) (h, rf) /\ lookupR rf ra <> 0) ->
    Infer (itpx1 (cdspec p g)) (jr ra).
Proof.
intros.
constructor.
intros.
unfold itpx1 in H0.
inversion_clear H0.
inversion_clear H2.
assert (g (h, rf) (h, rf) /\ lookupR rf ra <> 0).
apply H; auto.
inversion H0.
inversion_clear H2.
assert (lookupR rf ra = 0).
apply H3 with h; auto.
contradiction.
assert (exists p' : assert,
         (exists g' : action,
            lookupCT psi (lookupR rf ra) (cdspec p' g') /\
            p' (h, rf) /\ WFST (x - 1) (g' (h, rf)) psi)).
apply H4; auto.
intuition.
inversion_clear H8.
inversion_clear H9.
exists (cdspec x0 x1).
split.
intuition.
unfold itpx1.
split.
intuition.
exists (x - 1); intuition.
Save.

(** j f : direct jump *)
Lemma WF_j : 
  forall (p p' : assert) (g g' : action) (psi : codeheapty) (f : lab),
    lookupCT psi f (cdspec p' g') ->
    (forall (s : state), p s -> p' s) ->
    (forall (s s' : state), p s -> g' s s' -> g s s') ->
    Infer (itpx2 (itpx1 (cdspec p g)) psi) (j f).
Proof.
intros.
constructor.
intros.
unfold itpx2 in H2.
exists (cdspec p' g').
split.
apply psidom_insub_insup with psi; intuition.
inversion_clear H2.
unfold itpx1; unfold itpx1 in H4.
split.
apply H0; intuition.
inversion_clear H4.
inversion_clear H5.
exists x.
apply stack_strengthen with (g s).
intros.
apply H1; auto.
auto.
Save.

(** beq rs rt f *****)
Lemma WF_beq :
  forall (p p' p'' : assert) (g g' g'' : action) (psi : codeheapty) (f : lab)
    (rs rt : reg) (is : iseq),
    lookupCT psi f (cdspec p' g') ->
    Infer (itpx2 (itpx1 (cdspec p'' g'')) psi) is ->
    (forall (h : heap) (rf : rfile),
      p (h, rf) -> lookupR rf rs = lookupR rf rt -> p' (h, rf)) ->
    (forall (h : heap) (rf : rfile) (s' : state),
      p (h, rf) -> lookupR rf rs = lookupR rf rt -> g' (h, rf) s' ->
      g (h, rf) s') ->
    (forall (h : heap) (rf : rfile), 
      p (h, rf) -> lookupR rf rs <> lookupR rf rt -> p'' (h, rf)) ->
    (forall (h : heap) (rf : rfile) (s' : state),
      p (h, rf) -> lookupR rf rs <> lookupR rf rt -> g'' (h, rf) s' ->
      g (h, rf) s') ->
    Infer (itpx2 (itpx1 (cdspec p g)) psi) (seq (beq rs rt f) is).
Proof.
intros.
apply I_beq with (itpx2 (itpx1 (cdspec p'' g'')) psi).
intros.
split.
(* case rs <> rt *)
intros.
unfold itpx2 in H5; unfold itpx2.
split; intuition.
unfold itpx1 in H8; unfold itpx1.
split.
apply H3; intuition; auto.
inversion_clear H8.
inversion_clear H9.
exists x.
apply stack_strengthen with (g (h, rf)).
intros.
apply H4; auto.
assumption.

(* case rs = rt *)
intros.
exists (cdspec p' g').
split.
unfold itpx2 in H5.
apply psidom_insub_insup with psi; intuition.
unfold itpx2 in H5.
inversion_clear H5.
unfold itpx1 in H8; unfold itpx1.
inversion_clear H8.
inversion_clear H9.
split.
apply H1; auto.
exists x.
apply stack_strengthen with (g (h, rf)); auto.
auto.
Save.

(* bne rs rt f *)
Lemma WF_bne :
  forall (p p' p'' : assert) (g g' g'' : action) (psi : codeheapty) (f : lab)
    (rs rt : reg) (is : iseq),
    lookupCT psi f (cdspec p' g') ->
    Infer (itpx2 (itpx1 (cdspec p'' g'')) psi) is ->
    (forall (h : heap) (rf : rfile),
      p (h, rf) -> lookupR rf rs <> lookupR rf rt -> p' (h, rf)) ->
    (forall (h : heap) (rf : rfile) (s' : state),
      p (h, rf) -> lookupR rf rs <> lookupR rf rt -> g' (h, rf) s' ->
      g (h, rf) s') ->
    (forall (h : heap) (rf : rfile), 
      p (h, rf) -> lookupR rf rs = lookupR rf rt -> p'' (h, rf)) ->
    (forall (h : heap) (rf : rfile) (s' : state),
      p (h, rf) -> lookupR rf rs = lookupR rf rt -> g'' (h, rf) s' ->
      g (h, rf) s') ->
    Infer (itpx2 (itpx1 (cdspec p g)) psi) (seq (bne rs rt f) is).
Proof.
intros.
apply I_bne with (itpx2 (itpx1 (cdspec p'' g'')) psi).
intros.
split.
(* case rs = rt *)
intros.
unfold itpx2 in H5; unfold itpx2.
split; intuition.
unfold itpx1 in H8; unfold itpx1.
split.
apply H3; intuition; auto.
inversion_clear H8.
inversion_clear H9.
exists x.
apply stack_strengthen with (g (h, rf)).
intros.
apply H4; auto.
assumption.

(* case rs <> rt *)
intros.
exists (cdspec p' g').
split.
unfold itpx2 in H5.
apply psidom_insub_insup with psi; intuition.
unfold itpx2 in H5.
inversion_clear H5.
unfold itpx1 in H8; unfold itpx1.
inversion_clear H8.
inversion_clear H9.
split.
apply H1; auto.
exists x.
apply stack_strengthen with (g (h, rf)); auto.
auto.
Save.

Lemma WF_bgez :
  forall (p p' p'' : assert) (g g' g'' : action) (psi : codeheapty) (f : lab)
    (rs : reg) (is : iseq),
    lookupCT psi f (cdspec p' g') ->
    Infer (itpx2 (itpx1 (cdspec p'' g'')) psi) is ->
    (forall (h : heap) (rf : rfile),
      p (h, rf) -> lookupR rf rs >= 0 -> p' (h, rf)) ->
    (forall (h : heap) (rf : rfile) (s' : state),
      p (h, rf) -> lookupR rf rs >= 0 -> g' (h, rf) s' ->
      g (h, rf) s') ->
    (forall (h : heap) (rf : rfile), 
      p (h, rf) -> lookupR rf rs < 0 -> p'' (h, rf)) ->
    (forall (h : heap) (rf : rfile) (s' : state),
      p (h, rf) -> lookupR rf rs < 0 -> g'' (h, rf) s' ->
      g (h, rf) s') ->
    Infer (itpx2 (itpx1 (cdspec p g)) psi) (seq (bgez rs f) is).
Proof.
intros.
apply I_bgez with (itpx2 (itpx1 (cdspec p'' g'')) psi).
intros.
auto.
split.
(* case rs < 0 *)
intros.
unfold itpx2 in H5; unfold itpx2.
split; intuition.
unfold itpx1 in H8; unfold itpx1.
split.
apply H3; intuition; auto.
inversion_clear H8.
inversion_clear H9.
exists x.
apply stack_strengthen with (g (h, rf)).
intros.
apply H4; auto.
assumption.

(* case rs >= 0 *)
intros.
exists (cdspec p' g').
split.
unfold itpx2 in H5.
apply psidom_insub_insup with psi; intuition.
unfold itpx2 in H5.
inversion_clear H5.
unfold itpx1 in H8; unfold itpx1.
inversion_clear H8.
inversion_clear H9.
split.
apply H1; auto.
exists x.
apply stack_strengthen with (g (h, rf)); auto.
auto.
Save.

Lemma WF_bgtz :
  forall (p p' p'' : assert) (g g' g'' : action) (psi : codeheapty) (f : lab)
    (rs : reg) (is : iseq),
    lookupCT psi f (cdspec p' g') ->
    Infer (itpx2 (itpx1 (cdspec p'' g'')) psi) is ->
    (forall (h : heap) (rf : rfile),
      p (h, rf) -> lookupR rf rs > 0 -> p' (h, rf)) ->
    (forall (h : heap) (rf : rfile) (s' : state),
      p (h, rf) -> lookupR rf rs > 0 -> g' (h, rf) s' ->
      g (h, rf) s') ->
    (forall (h : heap) (rf : rfile), 
      p (h, rf) -> lookupR rf rs <= 0 -> p'' (h, rf)) ->
    (forall (h : heap) (rf : rfile) (s' : state),
      p (h, rf) -> lookupR rf rs <= 0 -> g'' (h, rf) s' ->
      g (h, rf) s') ->
    Infer (itpx2 (itpx1 (cdspec p g)) psi) (seq (bgtz rs f) is).
Proof.
intros.
apply I_bgtz with (itpx2 (itpx1 (cdspec p'' g'')) psi).
intros.
auto.
split.
(* case rs <= 0 *)
intros.
unfold itpx2 in H5; unfold itpx2.
split; intuition.
unfold itpx1 in H8; unfold itpx1.
split.
apply H3; intuition; auto.
inversion_clear H8.
inversion_clear H9.
exists x.
apply stack_strengthen with (g (h, rf)).
intros.
apply H4; auto.
assumption.

(* case rs > 0 *)
intros.
exists (cdspec p' g').
split.
unfold itpx2 in H5.
apply psidom_insub_insup with psi; intuition.
unfold itpx2 in H5.
inversion_clear H5.
unfold itpx1 in H8; unfold itpx1.
inversion_clear H8.
inversion_clear H9.
split.
apply H1; auto.
exists x.
apply stack_strengthen with (g (h, rf)); auto.
auto.
Save.

(* blez rs f *)
Lemma WF_blez :
  forall (p p' p'' : assert) (g g' g'' : action) (psi : codeheapty) (f : lab)
    (rs : reg) (is : iseq),
    lookupCT psi f (cdspec p' g') ->
    Infer (itpx2 (itpx1 (cdspec p'' g'')) psi) is ->
    (forall (h : heap) (rf : rfile),
      p (h, rf) -> lookupR rf rs <= 0 -> p' (h, rf)) ->
    (forall (h : heap) (rf : rfile) (s' : state),
      p (h, rf) -> lookupR rf rs <= 0 -> g' (h, rf) s' ->
      g (h, rf) s') ->
    (forall (h : heap) (rf : rfile), 
      p (h, rf) -> lookupR rf rs > 0 -> p'' (h, rf)) ->
    (forall (h : heap) (rf : rfile) (s' : state),
      p (h, rf) -> lookupR rf rs > 0 -> g'' (h, rf) s' ->
      g (h, rf) s') ->
    Infer (itpx2 (itpx1 (cdspec p g)) psi) (seq (blez rs f) is).
Proof.
intros.
apply I_blez with (itpx2 (itpx1 (cdspec p'' g'')) psi).
intros.
auto.
split.
(* case rs > 0 *)
intros.
unfold itpx2 in H5; unfold itpx2.
split; intuition.
unfold itpx1 in H8; unfold itpx1.
split.
apply H3; intuition; auto.
inversion_clear H8.
inversion_clear H9.
exists x.
apply stack_strengthen with (g (h, rf)).
intros.
apply H4; auto.
assumption.

(* case rs <= 0 *)
intros.
exists (cdspec p' g').
split.
unfold itpx2 in H5.
apply psidom_insub_insup with psi; intuition.
unfold itpx2 in H5.
inversion_clear H5.
unfold itpx1 in H8; unfold itpx1.
inversion_clear H8.
inversion_clear H9.
split.
apply H1; auto.
exists x.
apply stack_strengthen with (g (h, rf)); auto.
auto.
Save.

(* bltz rs f *)
Lemma WF_bltz :
  forall (p p' p'' : assert) (g g' g'' : action) (psi : codeheapty) (f : lab)
    (rs : reg) (is : iseq),
    lookupCT psi f (cdspec p' g') ->
    Infer (itpx2 (itpx1 (cdspec p'' g'')) psi) is ->
    (forall (h : heap) (rf : rfile),
      p (h, rf) -> lookupR rf rs < 0 -> p' (h, rf)) ->
    (forall (h : heap) (rf : rfile) (s' : state),
      p (h, rf) -> lookupR rf rs < 0 -> g' (h, rf) s' ->
      g (h, rf) s') ->
    (forall (h : heap) (rf : rfile), 
      p (h, rf) -> lookupR rf rs >= 0 -> p'' (h, rf)) ->
    (forall (h : heap) (rf : rfile) (s' : state),
      p (h, rf) -> lookupR rf rs >= 0 -> g'' (h, rf) s' ->
      g (h, rf) s') ->
    Infer (itpx2 (itpx1 (cdspec p g)) psi) (seq (bltz rs f) is).
Proof.
intros.
apply I_bltz with (itpx2 (itpx1 (cdspec p'' g'')) psi).
intros.
auto.
split.
(* case rs >= 0 *)
intros.
unfold itpx2 in H5; unfold itpx2.
split; intuition.
unfold itpx1 in H8; unfold itpx1.
split.
apply H3; intuition; auto.
inversion_clear H8.
inversion_clear H9.
exists x.
apply stack_strengthen with (g (h, rf)).
intros.
apply H4; auto.
assumption.

(* case rs < 0 *)
intros.
exists (cdspec p' g').
split.
unfold itpx2 in H5.
apply psidom_insub_insup with psi; intuition.
unfold itpx2 in H5.
inversion_clear H5.
unfold itpx1 in H8; unfold itpx1.
inversion_clear H8.
inversion_clear H9.
split.
apply H1; auto.
exists x.
apply stack_strengthen with (g (h, rf)); auto.
auto.
Save.

(*Lemma  addu rd rs rt *)
Lemma WF_addu : 
  forall (p p' : assert) (g g' : action) (rd rs rt : reg) 
    (is : iseq) (psi : codeheapty),
    (forall (s s' : state), p s -> next (addu rd rs rt) s s' -> p' s') ->
    (forall (s s' s'' : state), p s -> next (addu rd rs rt) s s' -> 
      g' s' s'' -> g s s'') ->
    Infer (itpx2 (itpx1 (cdspec p' g')) psi) is ->
    Infer (itpx2 (itpx1 (cdspec p g)) psi) (seq (addu rd rs rt) is).
Proof.
intros.
apply I_rest with (itpx2 (itpx1 (cdspec p' g')) psi).
intros.
induction s as [h rf].
exists ((h, updateR rf rd (lookupR rf rs + lookupR rf rt))).
split.
constructor.
unfold itpx2 in H2; unfold itpx2.
inversion_clear H2.
split; auto.
unfold itpx1 in H4; unfold itpx1.
inversion_clear H4.
inversion_clear H5.
split.
apply H with (h, rf).
auto.
constructor.
exists x.
apply stack_strengthen with (g (h, rf)).
intros.
apply H0 with (h, updateR rf rd (lookupR rf rs + lookupR rf rt)); auto.
constructor.
auto.
auto.
Save.

(*Lemma  addiu rd rs i *)
Lemma WF_addiu : 
  forall (p p' : assert) (g g' : action) (rd rs : reg) (i : nat) 
    (is : iseq) (psi : codeheapty),
    (forall (s s' : state), p s -> next (addiu rd rs i) s s' -> p' s') ->
    (forall (s s' s'' : state), p s -> next (addiu rd rs i) s s' -> 
      g' s' s'' -> g s s'') ->
    Infer (itpx2 (itpx1 (cdspec p' g')) psi) is ->
    Infer (itpx2 (itpx1 (cdspec p g)) psi) (seq (addiu rd rs i) is).
Proof.
intros.
apply I_rest with (itpx2 (itpx1 (cdspec p' g')) psi).
intros.
induction s as [h rf].
exists ((h, updateR rf rd (lookupR rf rs + i))).
split.
constructor.
unfold itpx2 in H2; unfold itpx2.
inversion_clear H2.
split; auto.
unfold itpx1 in H4; unfold itpx1.
inversion_clear H4.
inversion_clear H5.
split.
apply H with (h, rf).
auto.
constructor.
exists x.
apply stack_strengthen with (g (h, rf)).
intros.
apply H0 with (h, updateR rf rd (lookupR rf rs + i)); auto.
constructor.
auto.
auto.
Save.


(*Lemma  subu rd rs rt *)
Lemma WF_subu : 
  forall (p p' : assert) (g g' : action) (rd rs rt : reg) 
    (is : iseq) (psi : codeheapty),
    (forall (s s' : state), p s -> next (subu rd rs rt) s s' -> p' s') ->
    (forall (s s' s'' : state), p s -> next (subu rd rs rt) s s' -> 
      g' s' s'' -> g s s'') ->
    Infer (itpx2 (itpx1 (cdspec p' g')) psi) is ->
    Infer (itpx2 (itpx1 (cdspec p g)) psi) (seq (subu rd rs rt) is).
Proof.
intros.
apply I_rest with (itpx2 (itpx1 (cdspec p' g')) psi).
intros.
induction s as [h rf].
exists ((h, updateR rf rd (lookupR rf rs - lookupR rf rt))).
split.
constructor.
unfold itpx2 in H2; unfold itpx2.
inversion_clear H2.
split; auto.
unfold itpx1 in H4; unfold itpx1.
inversion_clear H4.
inversion_clear H5.
split.
apply H with (h, rf).
auto.
constructor.
exists x.
apply stack_strengthen with (g (h, rf)).
intros.
apply H0 with (h, updateR rf rd (lookupR rf rs - lookupR rf rt)); auto.
constructor.
auto.
auto.
Save.

(*Lemma  subiu rd rs i *)
Lemma WF_subiu : 
  forall (p p' : assert) (g g' : action) (rd rs : reg) (i : nat) 
    (is : iseq) (psi : codeheapty),
    (forall (s s' : state), p s -> next (subiu rd rs i) s s' -> p' s') ->
    (forall (s s' s'' : state), p s -> next (subiu rd rs i) s s' -> 
      g' s' s'' -> g s s'') ->
    Infer (itpx2 (itpx1 (cdspec p' g')) psi) is ->
    Infer (itpx2 (itpx1 (cdspec p g)) psi) (seq (subiu rd rs i) is).
Proof.
intros.
apply I_rest with (itpx2 (itpx1 (cdspec p' g')) psi).
intros.
induction s as [h rf].
exists ((h, updateR rf rd (lookupR rf rs - i))).
split.
constructor.
unfold itpx2 in H2; unfold itpx2.
inversion_clear H2.
split; auto.
unfold itpx1 in H4; unfold itpx1.
inversion_clear H4.
inversion_clear H5.
split.
apply H with (h, rf).
auto.
constructor.
exists x.
apply stack_strengthen with (g (h, rf)).
intros.
apply H0 with (h, updateR rf rd (lookupR rf rs - i)); auto.
constructor.
auto.
auto.
Save.


(** lemma lw **)
Lemma WF_lw :
  forall (psi : codeheapty) (p p' : assert) (g g' : action)
     (rd rs : reg) (i : nat) (is : iseq),
     (forall (h : heap) (rf : rfile), p (h, rf) ->
       hindom (lookupR rf rs + i) h) ->
     (forall (s s' : state), p s -> next (lw rd rs i) s s' -> p' s') ->
     (forall (s s' s'' : state), p s -> next (lw rd rs i) s s' -> g' s' s'' -> g s s'') ->
     Infer (itpx2 (itpx1 (cdspec p' g')) psi) is ->
     Infer (itpx2 (itpx1 (cdspec p g)) psi) (seq (lw rd rs i) is).
Proof.
intros.
apply I_rest with (itpx2 (itpx1 (cdspec p' g')) psi).
intros.
induction s as [h rf].
unfold itpx2 in H3; unfold itpx2.
inversion_clear H3.
unfold itpx1 in H5; unfold itpx1.
assert (exists x : nat, hread h (lookupR rf rs + i) = hvsome x).
assert (hindom (lookupR rf rs + i) h).
apply H; intuition.
inversion_clear H3.
exists v; auto.
inversion_clear H3.
exists (h, updateR rf rd x).
split.
constructor; auto.
split; auto.
split.
apply H0 with (h, rf); intuition.
constructor; auto.
inversion_clear H5.
inversion_clear H7.
exists x0.
apply stack_strengthen with (g (h, rf)).
intros.
apply H1 with (h, updateR rf rd x); auto.
constructor; assumption.
assumption.
assumption.
Save.

(** lemma lw_ **)
Lemma WF_lw_ :
  forall (psi : codeheapty) (p p' : assert) (g g' : action)
     (rd rs : reg) (i : nat) (is : iseq),
     (forall (h : heap) (rf : rfile), p (h, rf) ->
       hindom (lookupR rf rs - i) h) ->
     (forall (s s' : state), p s -> next (lw_ rd rs i) s s' -> p' s') ->
     (forall (s s' s'' : state), p s -> next (lw_ rd rs i) s s' -> g' s' s'' -> g s s'') ->
     Infer (itpx2 (itpx1 (cdspec p' g')) psi) is ->
     Infer (itpx2 (itpx1 (cdspec p g)) psi) (seq (lw_ rd rs i) is).
Proof.
intros.
apply I_rest with (itpx2 (itpx1 (cdspec p' g')) psi).
intros.
induction s as [h rf].
unfold itpx2 in H3; unfold itpx2.
inversion_clear H3.
unfold itpx1 in H5; unfold itpx1.
assert (exists x : nat, hread h (lookupR rf rs - i) = hvsome x).
assert (hindom (lookupR rf rs - i) h).
apply H; intuition.
inversion_clear H3.
exists v; auto.
inversion_clear H3.
exists (h, updateR rf rd x).
split.
constructor; auto.
split; auto.
split.
apply H0 with (h, rf); intuition.
constructor; auto.
inversion_clear H5.
inversion_clear H7.
exists x0.
apply stack_strengthen with (g (h, rf)).
intros.
apply H1 with (h, updateR rf rd x); auto.
constructor; assumption.
assumption.
assumption.
Save.


(** lemma sw rd i rs ***)

Lemma WF_sw :
  forall (psi : codeheapty) (p p' : assert) (g g' : action)
     (rd rs : reg) (i : nat) (is : iseq),
     (forall (h : heap) (rf : rfile), p (h, rf) ->
       hindom (lookupR rf rd + i) h) ->
     (forall (s s' : state), p s -> next (sw rd i rs) s s' -> p' s') ->
     (forall (s s' s'' : state), p s -> next (sw rd i rs) s s' -> g' s' s'' -> g s s'') ->
     Infer (itpx2 (itpx1 (cdspec p' g')) psi) is ->
     Infer (itpx2 (itpx1 (cdspec p g)) psi) (seq (sw rd i rs) is).
Proof.
intros.
intros.
apply I_rest with (itpx2 (itpx1 (cdspec p' g')) psi).
intros.
induction s as [h rf].
unfold itpx2 in H3; unfold itpx2.
inversion_clear H3.
unfold itpx1 in H5; unfold itpx1.
assert (exists x : nat, hread h (lookupR rf rd + i) = hvsome x).
assert (hindom (lookupR rf rd + i) h).
apply H; intuition.
inversion_clear H3.
exists v; auto.
inversion_clear H3.
exists (hwrite h (lookupR rf rd + i) (lookupR rf rs), rf).
intuition.
constructor; auto.
apply H0 with (h, rf); intuition.
constructor; auto.
inversion_clear H4.
inversion_clear H7.
exists x0.
apply stack_strengthen with (g (h, rf)).
intros.
apply H1 with (hwrite h (lookupR rf rd + i) (lookupR rf rs), rf); auto.
constructor;intuition.
assumption.
assumption.
Save.

(** lemma sw rd i rs ***)

Lemma WF_sw_ :
  forall (psi : codeheapty) (p p' : assert) (g g' : action)
     (rd rs : reg) (i : nat) (is : iseq),
     (forall (h : heap) (rf : rfile), p (h, rf) ->
       hindom (lookupR rf rd - i) h) ->
     (forall (s s' : state), p s -> next (sw_ rd i rs) s s' -> p' s') ->
     (forall (s s' s'' : state), p s -> next (sw_ rd i rs) s s' -> g' s' s'' -> g s s'') ->
     Infer (itpx2 (itpx1 (cdspec p' g')) psi) is ->
     Infer (itpx2 (itpx1 (cdspec p g)) psi) (seq (sw_ rd i rs) is).
Proof.
intros.
intros.
apply I_rest with (itpx2 (itpx1 (cdspec p' g')) psi).
intros.
induction s as [h rf].
unfold itpx2 in H3; unfold itpx2.
inversion_clear H3.
unfold itpx1 in H5; unfold itpx1.
assert (exists x : nat, hread h (lookupR rf rd - i) = hvsome x).
assert (hindom (lookupR rf rd - i) h).
apply H; intuition.
inversion_clear H3.
exists v; auto.
inversion_clear H3.
exists (hwrite h (lookupR rf rd - i) (lookupR rf rs), rf).
intuition.
constructor; auto.
apply H0 with (h, rf); intuition.
constructor; auto.
inversion_clear H4.
inversion_clear H7.
exists x0.
apply stack_strengthen with (g (h, rf)).
intros.
apply H1 with (hwrite h (lookupR rf rd - i) (lookupR rf rs), rf); auto.
constructor;intuition.
assumption.
assumption.
Save.









       
